package pwc.taxtech.atms.common;

public class CommonConstants {

    // enterprise account related constants start

    private CommonConstants() {
    }

    public static final String CLIENT_CODE = "pwc";
    public static final String INDUSTRY_Id = "23";
    /** JSON日期格式 */
    public static final String DATE_FORMAT = "yyyy-MM-dd'T'HH:mm:ss.SSSXXX";
    /** 默认Id地址 */
    public static final String DEFAULT_IP_ADDRESS = "127.0" + ".0.1";

    // used as message for ApplicationException in OrganizationConstructureService
    public static final String JSONNULLOBJECT = "json object is null";

    // used to skip createtime and update time while comparing properties between
    // new OrganizationConstructure and origin OrganizationConstructure
    // when setting operation log
    public static final String CREATETIME = "CREATETIME";

    public static final String UPDATETIME = "UPDATETIME";

    // java serialVersionUId, when comparing properties in two objects, this should
    // be skipped
    public static final String SERIALVERSIONUId = "SERIALVERSIONUId";

    public static final Integer REGION_LEVELTYPE_PROVINCE = 1;

    public static final Integer REGION_LEVELTYPE_CITY = 2;

    public static final Boolean ACTIVE_STATUS = true;

    public static final Boolean DEACTIVE_STATUS = false;

    public static final String PLUS_SIGN_SEPARATOR = "+";

    public static final int CODE_MAX_LENGTH = 50;
    public static final int NAME_MAX_LENGTH = 100;
    public static final String UPLOAD_FILE = "~/Upload/CustomerListImport";
    public static final String CODE = "Code";
    public static final String NAME = "Name";
    public static final String CUSTOMER_CODE = "CustomerCode";
    public static final String CUSTOMER_NAME = "CustomerName";
    public static final String CUSTOMER_CODE_ZHCN = "客户代码";
    public static final String CUSTOMER_NAME_ZHCN = "客户名称";
    public static final String CODE_ZHCN = "代码";
    public static final String NAME_ZHCN = "名称";
    public static final String IMPORT_APPEND = "2";
    public static final String IMPORT_OVERWRITE = "1";
    // customer related constants end

    // error start
    public static final String SAVE_FILE_ERROR = "SaveFileError";
    // error end
    public static final Boolean ADMIN_STATUS = true;
    public static final Boolean NON_ADMIN_STATUS = false;

    public static final String BasicDataManageMenu = "F9A18F3A-7E39-4661-BA00-F149710577C8";
    public static final String AdminHomePage = "#/adminHomePage";

    public static final Boolean IsHeritable = true;
    public static final Boolean IsNotHeritable = false;

    public static final Boolean IsAccessible = true;
    public static final Boolean IsNotAccessible = false;

    public static final Boolean HasOriginalRole = true;
    public static final Boolean HasNotOriginalRole = false;

    public static final Boolean IsLeaf = true;
    public static final Boolean IsNotLeaf = false;

    // START PwC.Tax.Tech.CIT.Globals\Utils\Constant.cs#Common
    public static final String strNull = "NULL";
    public static final String EmptyStdCode = "0000";
    public static final String NullStdCode = "00";
    public static final char CodeSeparator = '.';
    public static final String MailFrom = "noreply@cn.pwc.com";
    public static final String LocalHost = "127.0" + ".0.1";
    public static final String Asset = "资产";
    public static final String Debt = "负债";
    public static final String Joint = "共同";
    public static final String Equity = "权益";
    public static final String Cost = "成本";
    public static final String Loss = "损益";

    public static final String AssetValue = "1";
    public static final String DebtValue = "2";
    public static final String JointValue = "3";
    public static final String EquityValue = "4";
    public static final String CostValue = "5";
    public static final String LossValue = "6";

    public static final String DebitDirection = "1";
    public static final String CreditDirection = "-1";

    public static final String DebitDirectionName = "借";
    public static final String CreditDirectionName = "贷";

    public static final Integer DebitDirectionValue = 1;
    public static final Integer CreditDirectionValue = -1;

    public static final String DebitLogStr = "StandardAccountDebit";
    public static final String CreditLogStr = "StandardAccountCredit";

    public static final int MaxAttemptTimes = 5;
    public static final int MaxSamePasswordNumber = 6;
    public static final String LDAPUri = "LDAP://cn.asia.ad.pwcinternal.com";
    public static final String LDAP_DOMAIN = "CN";
    public static final char CustomerSplitSymbol = ',';
    public static final String DashboradRoleTypePrefix = "Dashboard";

    public static final String OperationObject = "Name";

    public static final String AssetLogStr = "StandardAccountAcctPropAsset";
    public static final String DebtLogStr = "StandardAccountAcctPropDebt";
    public static final String JointLogStr = "StandardAccountAcctPropCommon";
    public static final String EquityLogStr = "StandardAccountAcctPropInterest";
    public static final String CostLogStr = "StandardAccountAcctPropCost";
    public static final String LossLogStr = "StandardAccountAcctPropProfitAndLoss";

    public static final String IsActive = "IsActive";

    public static final String UploadFile = "~/Upload/DataInit";
    public static final String BasicDataTemplate = "userTemplate/basicData/commonTemplate.xlsx";
    public static final String BasicDataFileName = "commonTemplate";

    public static final String DashSignSeparator = "-";
    // END PwC.Tax.Tech.CIT.Globals\Utils\Constant.cs#Common
    public static final String EMPTY_UUID = "00000000-0000-0000-0000-000000000000";

    public static final Short ISACCESSIBLE_YES = 1;
    public static final Short ISACCESSIBLE_NO = 0;

    public static final String NullAreaId = "NullAreaId";
    public static final String CommonFail = "CommonFail";

    public static final String OneSpace = " ";
    public static final String Comma = ",";
}
