package pwc.taxtech.atms.common;

public enum OperationAction {

    New(1), 
    Update(2), 
    Delete(3),
    /**复制*/
    Copy(4),
    /**自动对应*/
    AutoMapping(5),
    /**手动对应*/
    ManualMapping(6),
    /**取消对应*/
    CancelMapping(7),
    /**添加账套*/
    AddEnterpriseAccountSet(8),
    /**修改账套*/
    UpdateEnterpriseAccountSet(9),
    /**添加科目*/
    AddEnterpriseAccount(10),
    /**修改科目*/
    UpdateEnterpriseAccount(11),
    /**关联机构*/
    AddRelevantOrgAction(12),
    /**修改关联机构*/
    UpdateRelevantOrg(13),
    /**删除机构*/
    DeleteRelevantOrg(14),
    /**新增用户*/
    AddNewUser(15),
    /**删除用户*/
    DeleteUser(16),
    /**新增权限*/
    AddNewPermission(17),
    /**去除权限*/
    DeletePermission(18),
    /**进入项目**/
    EnterProject(19);

    private int value;

    OperationAction(int value) {
        this.value = value;
    }

    public int value() {
        return value;
    }
    
    public static String getName(int value) {
        for(OperationAction action:OperationAction.values()) {
            if(action.value() == value) {
                return action.name();
            }
        }
        return null;
    }
}
