package pwc.taxtech.atms.dto.vatdto;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Getter;
import lombok.Setter;
import pwc.taxtech.atms.constant.enums.FormulaDataSourceType;

import java.math.BigDecimal;
import java.util.Date;

@Setter
@Getter
public class AssetDetailDataSourceDto extends FormulaDataSourceDto {
    public AssetDetailDataSourceDto() {
        super();
        this.setType(FormulaDataSourceType.AssetListSource.getCode());
    }

    public String assetNumber;
    public String assetGroupName;
    @JsonProperty("assetDetailGroupID")
    public String assetDetailGroupId;
    public String assetDescription;
    public Date buyDate;
    public Date depreciationDate;
    public Integer depreciationPeriod;
    public BigDecimal acquisitionValue;
    public BigDecimal adjustmentValue;
    public Date disposedDate;
    public BigDecimal residualRate;
    public BigDecimal yearDepreciationAmount;
    public BigDecimal yearAdjustmentAmount;
    public BigDecimal yearEndValue;
    public Integer status;
    public BigDecimal accountAcquisitionValue;
    public BigDecimal accountMonthDepreciationAmount;
    public BigDecimal accountYearDepreciationAmount;
    public BigDecimal accountTotalepreciationAmount;
    public Integer taxDepreciationPeriod;
    public Integer taxToLastYearDepreciationPeriod;
    public Integer taxToCurrentYearDepreciationPeriod;
    public Integer taxYearDepreciationPeriod;
    public BigDecimal taxMonthDepreciationAmount;
    public BigDecimal taxToCurrentYearDepreciationAmount;
    public BigDecimal taxCurrentYearDepreciationAmount;
    public BigDecimal totalDifferenceAmount;
    public BigDecimal yearDifferenceAmount;
    public Integer assetType;
    public Boolean isRetain;
    public String assetDetailGroupName;
    //判断是取哪一列的值
    public int dataType;
    public Integer detailGroupType;

}
