package pwc.taxtech.atms.dto.vatdto;

import lombok.Getter;
import lombok.Setter;
import pwc.taxtech.atms.constant.DataSourceName;
import pwc.taxtech.atms.constant.enums.FormulaDataSourceType;
import pwc.taxtech.atms.dpo.CellTemplatePerGroupDto;
import pwc.taxtech.atms.vat.entity.CellData;
import pwc.taxtech.atms.vat.entity.PeriodCellData;

import java.math.BigDecimal;

@Getter
@Setter
public class ReportCellDataSourceDto extends DataSourceDto {
    private String tag = "BB";
    private String name;
    private Integer year;
    private Integer period;
    private Integer columnIndex;
    private String columnName;
    private Integer rowIndex;
    private String rowName;
    private String reportTemplateId;
    private String reportName;
    private String cellDataId;
    private String cellTemplateId;
    private Boolean isOnlyManualInput;
    private Integer type;
    private Integer resultType;
    private BigDecimal amount;

    public ReportCellDataSourceDto() {
        this.type = FormulaDataSourceType.Report.getCode();
    }

    public static ReportCellDataSourceDto nullDataSource(BBParasBo bbParasBo, CurrentPeriodBo currentPeriodBo) {
        ReportCellDataSourceDto nulDataSource = new ReportCellDataSourceDto();
        nulDataSource.name = DataSourceName.ReportDataSource;
        nulDataSource.reportTemplateId = bbParasBo.getReportCode();
        nulDataSource.year = currentPeriodBo.curYear;
        nulDataSource.period = currentPeriodBo.getCurPeriod();
        nulDataSource.columnIndex = bbParasBo.getColumnIndex() - 1;
        nulDataSource.rowIndex = bbParasBo.getRowIndex() - 1;
        nulDataSource.isOnlyManualInput = false;
        nulDataSource.reportName = bbParasBo.getReportCode();
        return nulDataSource;
    }

    public void extractFromGroup(BBParasBo bbParasBo, CurrentPeriodBo currentPeriodBo,
                                 PeriodCellData cellData, CellTemplatePerGroupDto cellTemplateData) {
        this.name = DataSourceName.ReportDataSource;
        this.year = currentPeriodBo.curYear;
        this.period = currentPeriodBo.curPeriod;
        this.columnIndex = bbParasBo.getColumnIndex() - 1;
        this.columnName = cellTemplateData.getColumnName();
        this.rowIndex = bbParasBo.getRowIndex() - 1;
        this.rowName = cellTemplateData.getRowName();
        this.reportTemplateId = cellTemplateData.getReportTemplateId();
        this.cellDataId = cellData.getId() + "";
        this.cellTemplateId = cellData.getCellTemplateId() + "";
        this.resultType = cellTemplateData.getResultType();
        this.isOnlyManualInput = false;
        this.reportName = bbParasBo.getReportCode();
    }

    public void extractFromGroup(BBParasBo bbParasBo, Integer period, Integer year,
                                 CellTemplatePerGroupDto cellTemplateData) {
        this.name = DataSourceName.ReportDataSource;
        this.year = year;
        this.period = period;
        this.columnIndex = bbParasBo.getColumnIndex() - 1;
        this.columnName = cellTemplateData.getColumnName();
        this.rowIndex = bbParasBo.getRowIndex() - 1;
        this.rowName = cellTemplateData.getRowName();
        this.reportTemplateId = cellTemplateData.getReportTemplateId();
        this.cellTemplateId = cellTemplateData.getCellTemplateId() + "";
        this.resultType = cellTemplateData.getResultType();
        this.isOnlyManualInput = false;
        this.reportName = bbParasBo.getReportCode();
    }

    public void fixedWithGroup(CellTemplatePerGroupDto dto) {
        cellTemplateId = dto.getCellTemplateId();
        rowName = dto.getRowName();
        columnName = dto.getColumnName();
        reportTemplateId = dto.getReportTemplateId();
        resultType = dto.getResultType();
    }
}
