package pwc.taxtech.atms.vat.service.impl.report.functions;

import lombok.Getter;
import lombok.Setter;
import pwc.taxtech.atms.entity.Project;
import pwc.taxtech.atms.vat.service.impl.FormulaAgent;

@Setter
@Getter
public class FormulaContext {
    private String projectId;
    private Long reportTemplateGroupId;
    private Long reportId;
    private String organizationId;
    private Integer period;
    private Integer year;
    private Boolean isYear;
    private String indexResultId;
    private Integer yearBeginPeriod;
    private Integer yearEndPeriod;
    private Boolean ifRound;
    private Boolean isValidation;
    private Boolean isDetailed;
    private Boolean isIndexAnalysis;
    private Boolean cacheHasIndexCode;

    /**
     * 如果BB公式在cache中取上期失败，是否去上期取
     */
    private Boolean ifCalcStackValue;

    /**
     * 如果为99，则实时计算；如果为-1，则不用于判断是否实时计算；其他情况会在对应时机计算并保存
     */
    private Integer calculateStatus;

    private FormulaAgent formulaAgent;

    //private Map<String, FormulaResult> replaceSpecialCellFormulaDic;

    public static FormulaContext extractContextFromProject(Project project){
        FormulaContext formulaContext = new FormulaContext();
        formulaContext.setProjectId(project.getId());
        formulaContext.setYear(project.getYear());
        formulaContext.setIfRound(true);
        formulaContext.setOrganizationId(project.getOrganizationId());
        formulaContext.setIfRound(true);
        return formulaContext;
    }

    public FormulaContext fixedFormula(Integer period,Long reportTemplateGroupId,FormulaAgent agent){
        this.period=period;
        this.formulaAgent=agent;
        this.reportTemplateGroupId=reportTemplateGroupId;
        this.isYear=(period==0);
        return this;
    }
}
