package pwc.taxtech.atms.common;

import org.apache.commons.io.FileUtils;
import org.apache.commons.lang3.StringUtils;
import org.junit.Test;
import pwc.taxtech.atms.CommonIT;
import pwc.taxtech.atms.entity.StandardAccount;

import java.io.File;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.List;

public class DataInitTest extends CommonIT {

    @Test
    public void initStandardAccount() {
        try {
            List<String> lines = FileUtils.readLines(new File("C:\\Users\\Eddie Wu\\Desktop\\隆基科目表（最终版）_1106.csv"), StandardCharsets.UTF_8);
            lines.remove(0);
            String[] parent1 = null;
            String[] parent2 = null;
            String[] parent3 = null;
            String[] parent4 = null;
            for (String line : lines) {
                if (StringUtils.isBlank(line)) {
                    continue;
                }
                String[] cols = line.split(",");
                String name = StringUtils.substringAfterLast(cols[7], "-");

                StandardAccount account = new StandardAccount();
                account.setId(CommonUtils.getUUID());
                account.setCode(cols[6]);
                account.setName(StringUtils.isBlank(name) ? cols[7] : name);

                if (StringUtils.isNotBlank(cols[0])) {
                    parent1 = cols;
                } else if (StringUtils.isNotBlank(cols[1])) {
                    parent2 = cols;
                    account.setParentCode(parent1[6]);
                } else if (StringUtils.isNotBlank(cols[2])) {
                    parent3 = cols;
                    account.setParentCode(parent2[6]);
                } else if (StringUtils.isNotBlank(cols[3])) {
                    parent4 = cols;
                    account.setParentCode(parent3[6]);
                }

                account.setFullName(cols[7]);
                account.setAcctProp(Integer.valueOf(cols[9]));
                int acctLevel = 1;
                if (StringUtils.isNotBlank(cols[1])) {
                    acctLevel = 2;
                } else if (StringUtils.isNotBlank(cols[2])) {
                    acctLevel = 3;
                } else if (StringUtils.isNotBlank(cols[3])) {
                    acctLevel = 4;
                } else if (StringUtils.isNotBlank(cols[4])) {
                    acctLevel = 5;
                }
                account.setAcctLevel(acctLevel);
                account.setDirection(Integer.valueOf(cols[10]) == 1 ? 1 : -1);
                account.setIsLeaf(acctLevel != 1);
                account.setRuleType(2);
                account.setIsActive(true);
                account.setEnglishName(cols[8]);
                account.setIndustryId("0");
                standardAccountMapper.insertSelective(account);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        System.out.println(CommonUtils.getUUID());
    }
}
