package pwc.taxtech.atms.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;

import pwc.taxtech.atms.MyMapper;
import pwc.taxtech.atms.entity.EnterpriseAccount;

@Mapper
public interface CustomAccountMapper extends MyMapper {

    @Select("SELECT ea.id,ea.Code,ea.Name,ea.PARENT_CODE,ea.FULL_NAME,"
            + "CASE WHEN am.STANDARD_ACCOUNT_CODE='0000' THEN am.STANDARD_ACCOUNT_CODE ELSE sa.Code END StdCode,"
            + "sa.Name StdName,sa.PARENT_CODE StdParentCode "
            + "FROM (SELECT * FROM ENTERPRISE_ACCOUNT where PARENT_CODE=#{parentCode} and ENTERPRISE_ACCOUNT_SET_ID=#{accountSetId}) ea "
            + "LEFT JOIN (SELECT * FROM ACCOUNT_MAPPING WHERE ORGANIZATION_ID=#{orgId} AND INDUSTRY_ID=#{industryId} AND ENTERPRISE_ACCOUNT_SET_ID=#{accountSetId}) am ON ea.Code=am.ENTERPRISE_ACCOUNT_CODE "
            + "LEFT JOIN (SELECT * FROM StandardAccount WHERE IndustryID=#{industryId}) sa ON am.STANDARD_ACCOUNT_CODE=sa.Code "
            + "ORDER BY ea.CODE")
    @Results({
        @Result(id = true, column = "id", property = "id"),
        @Result(column = "Code", property = "code"),
        @Result(column = "Name", property = "name"),
        @Result(column = "PARENT_CODE", property = "parentCode"),
        @Result(column = "FULL_NAME", property = "fullName"),
        @Result(column = "StdCode", property = "stdCode"),
        @Result(column = "StdName", property = "stdName")
        //@Result(column = "StdParentCode", property = "stdParentCode")
    })
    List<EnterpriseAccount> getMappingResult(@Param(value="accountSetId") String accountSetId,
            @Param(value="industryId") String industryId, @Param(value="orgId") String orgId,
            @Param(value="parentCode") String parentCode);
    
    
    
    @Select("SELECT COUNT(1) FROM Account_Mapping "
            + "WHERE Enterprise_Account_Code=#{enterpirseAccountCode} "
            + "AND Enterprise_Account_Set_ID=#{enterpriseAccountSetId} "
            + "AND Organization_ID=#{organizationId} "
            + "AND Industry_ID=#{organizationId} "
            + "AND Standard_Account_Code<>'0000'")
    Long countStandardAccounts(@Param(value="enterpriseAccountSetId") String enterpriseAccountSetId,
            @Param(value="enterpirseAccountCode") String enterpirseAccountCode, 
            @Param(value="industryId") String industryId,
            @Param(value="organizationId") String organizationId);
}
