package pwc.taxtech.atms.dao;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import pwc.taxtech.atms.MyMapper;
import pwc.taxtech.atms.dpo.CellTemplatePerGroupDto;
import pwc.taxtech.atms.dpo.GroupId;

import java.util.List;

@Mapper
public interface FormulaAdminMapper extends MyMapper {

    @Select("SELECT  " +
            "    cell_template.id AS cellTemplateID, " +
            "    template.id AS reportTemplateID, " +
            "    template.template_group_id AS reportTemplateGroupID, " +
            "    cell_template.row_index AS rowIndex, " +
            "    cell_template.column_index AS columnIndex, " +
            "    template.Code AS reportCode, " +
            "    cell_template.column_name AS columnName, " +
            "    cell_template.row_name AS rowName, " +
            "    cell_template.data_type AS resultType " +
            "FROM " +
            "    template " +
            "        JOIN " +
            "    cell_template ON template.id = cell_template.report_template_id " +
            "WHERE " +
            "    template.template_group_id = #{groupId}")
    List<CellTemplatePerGroupDto> getCellTemplatePerGroupDto(@Param("groupId") Long groupId);


    @Select("SELECT  " +
            "    rule.template_group_id as groupId, rule.is_default as isDefault " +
            "FROM " +
            "    Project p, " +
            "    tax_payer_report_rule rule " +
            "WHERE " +
            "    (p.OrganizationID = rule.organization_id " +
            "        OR rule.is_default = 1) " +
            "        AND p.id = #{projectId}")
    List<GroupId> getTemplateGroupId(@Param("projectId") String projectId);

    @Select("SELECT  " +
            "    p.ID " +
            "FROM " +
            "    Project p " +
            "        JOIN " +
            "    Project_Service_Type ps ON p.id = ps.Project_ID " +
            "WHERE " +
            "    ps.Service_Type_ID IN ('2' , '3') " +
            "        AND p.Year = #{year} " +
            "        AND p.Organization_ID = #{orgId} " +
            "        AND p.Is_Active = 1 " +
            " AND ROWNUM=1"+
            "ORDER BY ps.Service_Type_ID ")
    String getPastProjectId(@Param("year") int year, @Param("orgId") String organizationId);
}
