﻿basicDataModule
    .controller('BasicDataFinancialInfrastructureController', ['$scope', '$log', 'SweetAlert', 'organizationStructureService', '$translate', 'businessUnitService', 'customerService',
        function($scope, $log, SweetAlert, organizationStructureService, $translate, businessUnitService, customerService) {
            'use strict';

            var successAddMessage = $translate.instant('OrganizationStructureAddSuccess');
            var successEditMessage = $translate.instant('OrganizationStructureEditSuccess');
            var successDeleteMessage = $translate.instant('OrganizationStructureDeleteSuccess');
            var operationDeleteMessage = $translate.instant('OrganizationStructureOperationSuccess');
            var notAllowDisableMessage = $translate.instant('notAllowDisableMessage');


            $scope.add = function(newrow) {

                organizationStructureService.addOrganizationStructure(newrow).success(function(guid) {
                    SweetAlert.success(successAddMessage);
                });
            };

            $scope.edit = function(newcontent) {
                organizationStructureService.updateOrganizationStructure(newcontent).success(function(guid) {
                    SweetAlert.success(successEditMessage);
                });
            };

            $scope.remove = function(id) {
                organizationStructureService.deleteOrganizationStructure(id).success(function(guid) {
                    SweetAlert.success(successDeleteMessage);
                });
            };

            $scope.stop = function(id) {
                organizationStructureService.updateOrganizationStructure(id).success(function(successFlag) {
                    $scope.updateflag = successFlag;
                    $scope.$broadcast('to-child', successFlag);
                    if (successFlag) {
                        SweetAlert.success(operationDeleteMessage);
                    } else {
                        SweetAlert.warning(notAllowDisableMessage);
                    }
                });
            };

            //BusinessUnit
            $scope.addbs = function(newrow) {

                businessUnitService.addBusinessUnit(newrow).success(function(guid) {
                    SweetAlert.success(successAddMessage);
                });
            };

            $scope.editbs = function(newcontent) {
                businessUnitService.updateBusinessUnit(newcontent).success(function(guid) {
                    SweetAlert.success(successEditMessage);
                });
            };

            $scope.removebs = function(id) {
                businessUnitService.deleteBusinessUnit(id).success(function(guid) {
                    SweetAlert.success(successDeleteMessage);
                });
            };

            $scope.stopbs = function(id) {
                businessUnitService.updateBusinessUnit(id).success(function(successFlag) {
                    $scope.updateflag = successFlag;
                    $scope.$broadcast('to-child', successFlag);
                    if (successFlag) {
                        SweetAlert.success(operationDeleteMessage);
                    } else {
                        SweetAlert.warning(notAllowDisableMessage);
                    }
                });
            };

            $scope.showOperateLogPop = function() {
                $scope.isShowLog = true;
                // $('#showOperatePop').modal('show');
            };

            var getUserPermission = function() {

                var list = [];

                var basicData = constant.adminPermission.basicData;
                list.push(basicData.orangizationStructure.queryCode);
                list.push(basicData.businessUnit.queryCode);
                list.push(basicData.areaManage.queryCode);
                list.push(basicData.enterpriseAccountSet.queryCode);
                list.push(basicData.customerList.queryCode);

                $scope.$root.checkUserPermissionList(list).success(function(data) {

                    $scope.orangizationStructureShow = data[basicData.orangizationStructure.queryCode];
                    $scope.businessUnitShow = data[basicData.businessUnit.queryCode];
                    $scope.areaManageShow = data[basicData.areaManage.queryCode];
                    $scope.enterpriseAccountSetShow = data[basicData.enterpriseAccountSet.queryCode];
                    $scope.customerListShow = data[basicData.customerList.queryCode];

                });
            };

            (function initialize() {
                $log.debug('BasicDataInfrastructureController.ctor()...');

                getUserPermission();

            })();
        }
    ]);
