﻿basicDataModule
.controller('ProductManageController', ['$scope', '$log', 'SweetAlert', '$translate', '$timeout', 'productService',
    function ($scope, $log, SweetAlert, $translate, $timeout, productService) {
        'use strict';

        var loadData = function () {
            productService.getProductList().success(function (data) {
                $scope.productList = data;
                initDXGrid();
            });
        };

        var initDXGrid = function () {
            $scope.dataGridOptions = {
                dataSource: $scope.productList,
                showBorders: true,
                height: 535,
                columns: [
                    { caption: '年份', dataField: 'fYear' },
                    { caption: '产品标识', dataField: "fSetID" },
                    { caption: '产品编号', dataField: "fSetCode" },
                    { caption: '产品描述（名称）', dataField: "fSetName" },
                    { caption: '财务主管', dataField: "fManager" },
                    { caption: '启用年份', dataField: "fStartYear" },
                    { caption: '启用月份', dataField: "fStartMonth" },
                    { caption: '所属机构', dataField: "accountDepartment" }]
            };
        };

        (function initialize() {
            $log.debug('ProductManageController.ctor()...');
            loadData();
        })();
    }
]);
