﻿commonModule.
controller('editRegionModalController', ['$scope', '$log', '$translate', 'uiGridConstants', '$location', '$timeout', '$interval', 'areaRegionService', '$filter', 'SweetAlert', 'regionService', '$uibModal',
    function ($scope, $log, $translate, uiGridConstants, $location, $timeout, $interval, areaRegionService, $filter, SweetAlert, regionService, $uibModal) {

        var $ctrl = this;

        var loadProvinceAndCity = function () {

            regionService.getProvinceAndCityTreeList().success(function (data) {

                // 只取有效的数据
                //data = _.filter(data, function (num) { return num.isActive });
                //$scope.provinceList = _.filter(data, function (num) { return num.levelType === 1 });
                //$scope.allCityList = _.filter(data, function (num) { return num.levelType === 2 });
                $scope.provinceCityData = data;
            });
        };

        var getProvinceAndCityList = function (branch) {
            var citys = [];
            if (branch.data.isArea) {
                // 如果是自定义区域

                if (branch.items && branch.items.length > 0) {
                    branch.items.forEach(function (row) {
                        if (!row.data.isArea) {
                            var tempList = getProvinceAndCityList(row);

                            citys = _.union(citys, tempList);
                        }
                    });
                }


            } else {
                // 如果是行政区域, 省
                if (branch.items && branch.items.length > 0) {
                    var tempCities = [];
                    branch.items.forEach(function (row) {
                        citys.push({
                            id: row.id,
                            name: row.text,
                            level: 2,
                            status: 2,
                            parentId: row.parentId
                        });
                    });

                } else {
                    // 市
                }
            }

            return citys;
        };

        var getLabelName = function (item) {

            if (item.items.length == 0) {
                selectedCityList.push(item.label);
                return;
            }

            item.items.forEach(function (itm) {
                getLabelName(itm);
            });
        };

        $scope.$watch('operateType', function (newValue, oldValue) {
            if (newValue) {

                if (newValue == 'add') {
                    // add

                    $scope.isAdd = true;

                    // if (!$scope.selectedRegion) {
                    //     $scope.selectedRegion = {

                    //         // 父节点默认大中华区
                    //         id: '000000',
                    //         name: '大中华区'
                    //     };
                    // }

                    thisModalService.newModel();
                } else if (newValue == 'edit' && $scope.selectedRegion && $scope.selectedRegion.id) {
                    thisModalService.loadModel();
                }
            }
        });

        var thisDataService = {
            newModel: function () {
                var editModel = {};
                editModel.isActive = true;
                editModel.RegionNames = [];
                editModel.selectedNodeList = [];
                editModel.isAdd = true;
                editModel.areaName = '';

                return editModel;
            },
            save: function () {

                var validateTemp = getValidateService();
                validateTemp.resetErrorStatus();
                if (!($('#addRegionControlForm').valid())) {
                    return;
                }

                var areaId = $scope.editModel ? $scope.editModel.id : null;
                var parentId = $scope.editModel ? $scope.editModel.parentID : null;
                var name = $scope.editModel.areaName;
                var selectedCity = $scope.editModel.selectedNodeList;

                if (!$scope.editModel.id) {
                    // 添加
                    var saveModel = {
                        parentId: areaId,
                        name: name,
                        cityList: selectedCity
                    };

                    areaRegionService.add(saveModel).success(function (data) {
                        if (!data.result) {
                            swal($translate.instant('SaveFail'), $translate.instant(data.resultMsg), 'warning');
                            return;
                        }

                        SweetAlert.success($translate.instant('SaveSuccess'));
                        thisModalService.close($scope.editModel);
                    });
                } else {
                    var saveModel = {
                        id: areaId,
                        parentId: parentId,
                        name: name,
                        cityList: selectedCity,
                        isActive: $scope.editModel.isActive
                    };

                    areaRegionService.update(saveModel).success(function (data) {
                        if (!data.result) {
                            swal($translate.instant('SaveFail'), $translate.instant(data.resultMsg), 'warning');
                            return;
                        }

                        SweetAlert.success($translate.instant('SaveSuccess'));
                        thisModalService.close($scope.editModel);
                    });
                }
            }
        };

        var thisModalService = {
            modalInstance: null,
            open: function (editModel) {
                $scope.editModel = editModel;
                var modalInstance = $uibModal.open({
                    animation: $ctrl.animationsEnabled,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'editRegionModal.html',
                    scope: $scope,
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function (data) {
                    $ctrl.editModel = data;
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                }, function () {
                    $scope.operateType = null;
                    $scope.isUpdate = false;
                    $log.info('Modal dismissed at: ' + new Date());
                });

                thisModalService.modalInstance = modalInstance;

                // 确定
                $scope.save = thisDataService.save;

                // 取消
                $scope.cancel = thisModalService.cancel;
            },
            newModel: function () {
                var editModel = thisDataService.newModel();
                thisModalService.open(editModel);
            },
            loadModel: function () {
                regionService.getAreRegionTreeByNodeID($scope.selectedRegion.id).success(function (data) {
                    if (data && data.length > 0) {
                        $scope.selectedBranch = data[0];
                        // this action only get active area
                        $scope.selectedBranch.isActive = true;
                        //$scope.selectedRegion = data[0].data;

                        var editModel = data[0];
                        editModel.SelectedCityList = getProvinceAndCityList(editModel);
                        editModel.IsEdit = true;
                        editModel.areaName = $scope.selectedBranch.text;
                        editModel.isAdd = false;
                        thisModalService.open(editModel);
                    }
                });
            },
            close: function (result) {
                if (thisModalService.modalInstance) {
                    thisModalService.modalInstance.close(result);
                }
            },
            cancel: function () {
                if (thisModalService.modalInstance) {
                    thisModalService.modalInstance.dismiss('cancel');
                }
            }
        };

        var getValidateService = function () {

            var resources = {
                provinceRequired: $translate.instant('ProvinceRequired'),
                areaNameRequired: $translate.instant('AreaNameRequired')
            };

            // 数据验证相关方法
            var validator = $("#addRegionControlForm").validate({
                errorClass: "has-error",
                rules: {
                    province: {
                        required: true
                    },
                    areaName: {
                        required: true,
                        maxlength: 50
                    }
                },
                messages: {
                    province: {
                        required: resources.provinceRequired
                    },
                    areaName: {
                        required: resources.areaNameRequired,
                        maxlength: $translate.instant('AreaNameOutOfLengthNode')
                    }
                },
                errorPlacement: function (error, element) {
                    setErrorStyle(error, element);
                }
            });

            // 设置错误样式
            var setErrorStyle = function (error, element) {
                if (element.hasClass('has-error')) {
                    element.parent().addClass('has-error');
                    error.insertAfter(element);
                    error.addClass('label');
                    // error.addClass('label-danger');
                }
            };

            // 重置错误样式
            var resetErrorStatus = function () {
                var currentForm = $('#addRegionControlForm');
                $.each(currentForm.children(), function (index, element) {
                    // $(element).find('.has-error').removeClass('has-error');

                    $(element).find('.has-error label').remove();
                });
                validator.resetForm();
            };


            return {
                validator: validator,
                setErrorStyle: setErrorStyle,
                resetErrorStatus: resetErrorStatus
            };
        };

        (function initialize() {
            $log.debug('editRegionModalController.ctor()...');

            //loadProvinceAndCity();
        })();
    }
]);

