﻿commonModule.controller('importJournalEntryController', ['$scope', '$log', 'loginContext', '$translate', 'apiInterceptor', 'Upload', 'dataImportService'
    , 'SweetAlert', 'vatImportService', '$timeout', '$q', 'enums', 'uiGridConstants', '$interval'
    , 'citSessionService', 'vatOperationLogService', 'projectService', 'vatCommonService', '$uibModal',
 function ($scope, $log, loginContext, $translate, apiInterceptor, Upload, dataImportService, SweetAlert
     , vatImportService, $timeout, $q, enums, uiGridConstants, $interval
     , citSessionService, vatOperationLogService, projectService, vatCommonService, $uibModal) {
     'use strict';

     var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
     var successCount = 0;
     var resumable = true;
     var curPeriod = $scope.periodId;//citSessionService.month; //从页面顶部的选择月份获取月份跟年份
     var curYear = citSessionService.project.year;
     var projectID = citSessionService.project.id;
     var projectDbName = citSessionService.project.dbName;
     var comment = citSessionService.project.name + " " + citSessionService.project.year + $translate.instant('Year')
                 + citSessionService.month + $translate.instant('month');
     var token = $('input[name="__RequestVerificationToken"]').val();


     //导入方式 
     $scope.importEnum = {
         Import: 0,
         CoverImport: 1,
         AddImport: 2
     };
     $scope.chunkSize = 100000;
     $scope.columnNum = 0;
     $scope.selectedPeriod;
     $scope.showImportTable = false; //是否显示导入table
     $scope.showInitTable = false; //是否显示初始数据ui-grid
     $scope.showErrorTable = false; //是否显示错误信息列表       
     $scope.period = citSessionService.month;
     $scope.moduleid = enums.vatModuleEnum.Import_JournalEntry;

     var logDto = {
         ID: '',
         OperationName: '',
         ModuleID: $scope.moduleid,
         OperationObject: $translate.instant('JournalEntryTitle'),
         OperationType: '',
         OperationContent: '',
         OriginalState: '',
         UpdateState: '',
         CreatorID: citSessionService.logUser.ID,
         Comment: comment,
         IP: '',
         Period: $scope.period,
     };

     var validationErrorType = {
         ColumnsMapErrorType: $translate.instant('ColumnsMapErrorType'),
         JournalEntryVIDEmptyErrorType: $translate.instant('JournalEntryVIDEmptyErrorType'),
         JournalEntryGroupEmptyErrorType: $translate.instant('JournalEntryGroupEmptyErrorType'),
         JournalEntryItemIDEmptyErrorType: $translate.instant('JournalEntryItemIDEmptyErrorType'),
         JournalEntryAcctCodeEmptyErrorType: $translate.instant('JournalEntryAcctCodeEmptyErrorType'),
         JournalEntryVoucherDateEmptyErrorType: $translate.instant('JournalEntryVoucherDateEmptyErrorType'),
         JournalEntryDateFormatErrorType: $translate.instant('JournalEntryDateFormatErrorType'),
         JournalEntryAmountErrorType: $translate.instant('JournalEntryAmountErrorType'),
         JournalEntryItemIDFormatErrorType: $translate.instant('JournalEntryItemIDFormatErrorType'),
         JournalEntryPeriodFormatErrorType: $translate.instant('JournalEntryPeriodFormatErrorType'),
         NumOutRangeErrorType: $translate.instant('NumOutRangeErrorType'),
         OutputStringLengthType: $translate.instant('OutputStringLengthType'),
         StartRowError: $translate.instant('StartRowError')
     };


     //初始化ack-pagination
     $scope.pagingOptions = {
         pageIndex: 1, //当前页码
         totalItems: 0, //总数据
         totalPages: 10, //总页数
         maxSize: 5, //分页数字的限制。
         pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
         pageSizeString: constant.page.pageSizeArrary[3].toString(),
         firstPage: $translate.instant('PagingFirstPage'),
         previousPage: $translate.instant('PagingPreviousPage'),
         nextPage: $translate.instant('PagingNextPage'),
         lastPage: $translate.instant('PagingLastPage'),
     };

     //初始化查询参数
     $scope.queryParams = {
         pageInfo: {
             totalCount: 0,
             pageIndex: 0,
             pageSize: 0,
             totalPage: 0,
         },
         periodId: curPeriod
     };

     //初始化汇总参数
     $scope.totalData = {
         totalNumber: 0,
         debit: 0,
         credit: 0
     };


     //初始化列数据
     var initColumns = function () {
         //初始化进项发票汇总表列名（包括请选择列）
         $scope.journalEntryColumns = [
          $translate.instant('PleaseSelectColumn'),
          $translate.instant('JournalPZRQ'),
          $translate.instant('JournalPZLX'),
          $translate.instant('JournalPZH'),
          $translate.instant('JournalFLH'),
          $translate.instant('JournalQJ'),
          $translate.instant('JournalKMDM'),
          $translate.instant('JournalZY'),
          $translate.instant('JournalJFJE'),
          $translate.instant('JournalDFJE'),
          $translate.instant('JournalKHDM')
         ];

         $scope.initJournalEntryColumnsIndex = _.range(1, $scope.journalEntryColumns.length);

         //序时账所有列
         $scope.journalEntryAllColumns = [
          $translate.instant('JournalPZRQ'),
          $translate.instant('JournalPZLX'),
          $translate.instant('JournalPZH'),
          $translate.instant('JournalFLH'),
          $translate.instant('JournalQJ'),
          $translate.instant('JournalKMDM'),
          $translate.instant('JournalZY'),
          $translate.instant('JournalJFJE'),
          $translate.instant('JournalDFJE'),
          $translate.instant('JournalKHDM')
         ];

         //必须进行map的列
         $scope.mustMappingTotalColumns = [
          $translate.instant('JournalPZRQ'),
          $translate.instant('JournalPZLX'),
          $translate.instant('JournalPZH'),
          $translate.instant('JournalFLH'),
          $translate.instant('JournalKMDM'),
          $translate.instant('JournalJFJE'),
          $translate.instant('JournalDFJE')
          //$translate.instant('JournalKHDM')
         ];
     };


     //从数据库中load数据，如果有，则页面导入按钮为覆盖导入或追加导入，否则为导入按钮
     var loadJournalEntryDataFromDB = function () {
         $scope.queryParams.periodId = curPeriod;
         $scope.queryParams.pageInfo = {
             totalCount: $scope.pagingOptions.totalItems,
             pageIndex: $scope.pagingOptions.pageIndex,
             pageSize: $scope.pagingOptions.pageSize,
             totalPage: 0,
         };
         vatImportService.queryJournalEntryData($scope.queryParams).success(function (re) {
             if (re) {
                 $scope.sheetData = {
                     sheetNameList: [],
                     dataList: [],
                     selectedSheetIndex: 0
                 };
                 var data = re.list;
                 var index = 1;
                 var debitSum = 0;
                 var creditSum = 0;
                 initPagingControl(re.pageInfo.totalCount);
                 data.forEach(function (v) {
                     v.index = index++;
                     v.debit = PWC.round(v.debit, 2);
                     v.credit = PWC.round(v.credit, 2);
                 });
                 $scope.initJournalEntryList = data;
                 $scope.gridOptionsJournalEntry.data = data;
                 $scope.totalData.totalNumber = re.pageInfo.totalCount;
                 $scope.totalData.debit = PWC.round(re.calculateData.debitSum, 2);
                 $scope.totalData.credit = PWC.round(re.calculateData.creditSum, 2);
                 $scope.itemIDCount = re.calculateData.itemIDCount;
                 $scope.vidCount = re.calculateData.vidCount;
                 //当数据库中数据>=0时，就显示初始化数据ui-grid，
                 //但是需要当数据库中数据大于0时才不显示导入按钮，而显示覆盖导入和追加导入按钮
                 if (data.length >= 0) {
                     if (data.length > 0) {
                         $scope.isShowImportTotalBtn = false;
                     }
                     $scope.showInitTable = true;
                     $scope.showImportTable = false;
                 }
                 //获取错误列表信息
                 getValidationList().then(function () {
                     if ($scope.errorList.length > 0) {
                         showErrTab();
                         $scope.toggleErrorTab();

                         //当有错误信息时，显示错误信息表
                         $scope.showErrorTable = true;
                     } else {
                         $scope.ImportErrorTab = false;
                         $scope.ImportErrorTag = false;
                         $scope.showErrorTable = false;
                     }
                 });
                 setJeGridColumns(data);                
             }

         });
     };


     //设置序时账Grid的columns
     var setJeGridColumns = function (data){
         if (data && data.length > 0) {
             $scope.gridOptionsJournalEntry.columnDefs = [{
                 name: $translate.instant('ImportErrorPopUpNoCol'),
                 width: 100,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
             }, {
                 name: $translate.instant('JournalPZRQ'),
                 width: 150,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.date | date:"yyyy-MM-dd"}}<span></div>'
             }];
             //判断期间列是否需要显示
             if (data[0].monthID != null) {
                 $scope.gridOptionsJournalEntry.columnDefs.push({
                     name: $translate.instant('JournalQJ'),
                     width: 100,
                     headerCellClass: 'right',
                     cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.period}}</span></div>'
                 });
             }

             $scope.gridOptionsJournalEntry.columnDefs.push({
                 name: $translate.instant('JournalPZLX'),
                 width: 150,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.group}}">{{row.entity.group}}<span></div>'
             }, {
                 name: $translate.instant('JournalPZH'),
                 width: 200,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.group}}">{{row.entity.vid}}</span></div>'
             }, {
                 name: $translate.instant('JournalKMDM'),
                 width: 150,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span  title="{{row.entity.acctCode}}">{{row.entity.acctCode}}</span></div>'
             });

             //判断是否需要显示摘要列
             if (data[0].summary != null) {
                 $scope.gridOptionsJournalEntry.columnDefs.push({
                     name: $translate.instant('JournalZY'),
                     width: 200,
                     headerCellClass: '',
                     cellTemplate: '<div class="ui-grid-cell-contents"><span  title="{{row.entity.summary}}">{{row.entity.summary}}</span></div>'
                 });
             }

             $scope.gridOptionsJournalEntry.columnDefs.push({
                 name: $translate.instant('JournalJFJE'),
                 width: 150,
                 headerCellClass: 'right',
                 cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.debit}}</span></div>'
             }, {
                 name: $translate.instant('JournalDFJE'),
                 width: 150,
                 headerCellClass: 'right',
                 cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.credit}}</span></div>'
             }, {
                 name: $translate.instant('JournalKHDM'),
                 width: 150,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.customerCode}}</span></div>'
             }, {
                 name: $translate.instant('JournalFLH'),
                 width: 100,
                 headerCellClass: 'right',
                 cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.itemID}}</span></div>'
             });
         } else {
             $scope.gridOptionsJournalEntry.columnDefs = [{
                 name: $translate.instant('ImportErrorPopUpNoCol'),
                 width: 100,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
             }, {
                 name: $translate.instant('JournalPZRQ'),
                 width: 150,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.date | date:"yyyy-MM-dd"}}<span></div>'
             }, {
                 name: $translate.instant('JournalQJ'),
                 width: 100,
                 headerCellClass: 'right',
                 cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.period}}</span></div>'
             }, {
                 name: $translate.instant('JournalPZLX'),
                 width: 150,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.group}}<span></div>'
             }, {
                 name: $translate.instant('JournalPZH'),
                 width: 200,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.vid}}</span></div>'
             }, {
                 name: $translate.instant('JournalKMDM'),
                 width: 150,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctCode}}</span></div>'
             }, {
                 name: $translate.instant('JournalZY'),
                 width: 200,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.summary}}</span></div>'
             }, {
                 name: $translate.instant('JournalJFJE'),
                 width: 150,
                 headerCellClass: 'right',
                 cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.debit}}</span></div>'
             }, {
                 name: $translate.instant('JournalDFJE'),
                 width: 150,
                 headerCellClass: 'right',
                 cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.credit}}</span></div>'
             }, {
                 name: $translate.instant('JournalKHDM'),
                 width: 150,
                 headerCellClass: '',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.customerCode}}</span></div>'
             }, {
                 name: $translate.instant('JournalFLH'),
                 width: 100,
                 headerCellClass: 'right',
                 cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.itemID}}</span></div>'
             }];
         }
     }


     //序时账选择列名事件
     //parentIndex：当前列号
     //index：下拉列表中选项的序号
     var mappingColumn = function (parentIndex, index, colName) {
         if (colName) {

             var oldColumn = $scope.selectedColumnMap[parentIndex];
             var newColumn = $scope.journalEntryColumns[index];

             //如果新的选择项与老的选择项一致，则不进行操作
             if (oldColumn === newColumn) {
                 return;
             } else {
                 $scope.selectedColumnMap[parentIndex] = colName;

                 if (colName !== $translate.instant('PleaseSelectColumn')) {
                     //如果当前选择的不是"请选择列名",则将选项从数组中移除
                     $scope.journalEntryColumns.splice(index, 1);

                     if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                         //将老的选项追加到选项列表中
                         $scope.journalEntryColumns.push(oldColumn);
                     }
                 } else {
                     //如果当前选中的是"请选择列名",则将该列原来的列名追加到选项列表中
                     if (oldColumn) {
                         $scope.journalEntryColumns.push(oldColumn);
                     }
                 }
             }
         }
         //$log.debug($scope.selectedColumnMap);
     };


     //设置上传文件的文件名
     var updateJournalEntryFileName = function (newValue) {
         $scope.fileName = newValue.name;
     };


     //上传文件
     var doUploadJournalEntryFile = function (file) {
         if (file) {
             var arr = file.name.split('.');
             if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                 SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                 return;
             }
             $scope.initJournalEntryList = [];
             $scope.gridOptionsJournalEntry.data = [];
             successCount = 0;
             if (!file.$error) {
                 var tempFileName = PWC.newGuid() + '.dat';
                 Upload.upload({
                     url: uploadUrl,
                     data: {
                         filename: file.name,
                         tempFileName: tempFileName,
                         file: file
                     },
                     resumeChunkSize: resumable ? $scope.chunkSize : null,
                     headers: {
                         'Access-Control-Allow-Origin': '*',
                         Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()
                     },
                     __RequestVerificationToken: token,
                     withCredentials: true
                 }).then(uploadJournalEntrySuccess);
             }
         }
     };


     //上传成功后执行函数
     var uploadJournalEntrySuccess = function (resp) {
         console.log(resp);
         successCount++;
         if (successCount === 1) {
             $scope.tempFileName = resp.data;
             //初始化到excel文件的第一个sheet
             changeJournalEntrySheet(0);
         }
     };


     //初始化需要展示的sheet
     var changeJournalEntrySheet = function (selectedSheet) {
         var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
             return num.name === selectedSheet.name;
         })
         $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
         refreshJournalEntryTable();
     };


     //重新load页面上的table
     //做column mapping时只加载constant.pageSize行数据
     var refreshJournalEntryTable = function () {
         //在切换显示页面导入数据时，直接设置初始化数据ui-grid表不可见，错误信息不可见
         //导入数据表格可见
         $scope.showImportTable = true;
         $scope.showErrorTable = false;
         $scope.showInitTable = false;

         if (_.isString($scope.tempFileName)) {
             $scope.sheetData = {
                 sheetNameList: [],
                 dataList: [],
                 selectedSheetIndex: 0
             };
             $scope.columnNum = 0;
             $scope.selectedColumnMap = [];

             vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, constant.pageSize).success(function (data) {
                 //将导入文件的sheet赋值到数组
                 $scope.sheetData = data;
                 //加入index序号
                 var index = 1;
                 data.dataList.forEach(function (v) {
                     v.index = index++;
                 });
                 var sheetNameObjectArray = [];
                 data.sheetNameList.forEach(function (v) {
                     sheetNameObjectArray.push({
                         'name': v
                     });
                 });
                 $scope.sheetData.sheetNameList = sheetNameObjectArray;

                 $scope.columnNum = data.dataList[0] ? data.dataList[0].length : $scope.columnNum;
                 $scope.firstDataRow = data.dataList[0];
                 $scope.startRowList = _.range(data.lastRowIndex);
                 $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                 initColumns();
                 citSessionService.dataChanged = true; //设置为true表示在切换页面前数据有变更, 需要提示

                 if (data & data.result === false) {
                     SweetAlert.warning(data.resultMsg);
                     return;
                 }
             });
         }
     };


     //对导入数据进行验证(前端)
     var FrontEndValidJournalEntryData = function (journalEntryList) {
         //2:验证关键字段不为空（凭证号，凭证类型，分录号，科目代码）
         //3:验证日期、金额格式、期间格式、分录号格式是否正确
         if (!KeyColumnsEmptyValid(journalEntryList)) {
             return;
         }

         //4:所有验证都通过后，筛选符合期间条件的数据进库
         FilterPeriodData(journalEntryList);

     };


     //1.判断是否有没有map的必须列和起始行输入格式是否正确
     var ColumnsMapCheck = function () {
         var result = true;
         var notMappedColumns = '';
         if ($scope.selectedColumnMap.length >= 0) {
             var count1 = 0;
             $scope.mustMappingTotalColumns.forEach(function (m) {
                 if (m !== $translate.instant('PleaseSelectColumn')) {
                     if ($.inArray(m, $scope.selectedColumnMap) < 0) {
                         notMappedColumns += m + ',';
                         count1++;
                     }
                 }
             });
             if (count1) {
                 result = false;
                 //加入到错误列表中
                 $scope.errorMsgMap.push({
                     'errorType': validationErrorType.ColumnsMapErrorType,
                     'errorCount': count1,
                     'errorContent': $translate.instant('ColumnsMapErrorMsg').formatObj({
                         columns: notMappedColumns.substring(0, notMappedColumns.length - 1)
                     })
                 });
             }
         }
         //2:判断起始行输入框输入内容是否合理
         var startNumberCheckMsg = '';
         var startRowNum = $('#StartRowNum').val();
         if (startRowNum === '') {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.StartRowError,
                 'errorCount': 1,
                 'errorContent': $translate.instant('StartRowNull')
             });
         } else if (parseInt(startRowNum) > $scope.sheetData.dataList.length) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.StartRowError,
                 'errorCount': 1,
                 'errorContent': $translate.instant('StartRowNumberCheckMsg')
             });
         }
         return result;
     };


     //2.验证关键字段不为空（凭证号，凭证类型，分录号，科目代码）
     //3.验证日期、金额格式、期间格式、分录号格式是否正确
     var KeyColumnsEmptyValid = function (journalEntryList) {
         var result = true;
         //#region 定义错误信息

         //凭证号为空
         var VIDEmptyCheckMsg = '';
         var VIDEmptyCheckCount = 0;
         //科目代码为空
         var AcctCodeEmptyCheckMsg = '';
         var AcctCodeEmptyCheckCount = 0;
         //验证凭证日期为空
         var VoucherDateEmptyErrorMsg = '';
         var VoucherDateEmptyErrorCount = 0;

         //验证凭证日期格式错误
         var VourcharDateFormatErrorMsg = '';
         var VourcharDateFormatErrorCount = 0;

         //验证借方金额、贷方金额格式错误
         var AmountFormatErrorMsg = '';
         var AmountFormatErrorCount = 0;

         //验证期间是否是正整数
         var PeriodFormatErrorMsg = '';
         var PeriodFormatErrorCount = 0;

         //验证分录号是否为正整数
         //var ItemIDFormatErrorMsg = '';
         //var ItemIDFormatErrorCount = 0;

         //数据范围超出范围
         var numOutRangeCheckMsg = '';
         var numOutRangeCheckCount = 0;

         //字符长度过长验证
         var stringOverLengthCheckMsg = '';
         var stringOverLengthCheckCount = 0;

         //凭证类型为空
         var groupEmptyCheckMsg = '';
         var groupEmptyCheckCount = 0;

         //分录号为空
         var itemEmptyCheckMeg = '';
         var itemEmptyCheckCount = 0;

         //#endregion

         //#region 验证错误信息
         journalEntryList.forEach(function (m) {
             var tempVID = PWC.isNullOrEmpty(m.VID) ? $translate.instant('NullValue') : m.VID;
             var tempGroup = PWC.isNullOrEmpty(m.Group) ? $translate.instant('NullValue') : m.Group;
             var tempItemID = PWC.isNullOrEmpty(m.ItemID) ? $translate.instant('NullValue') : m.ItemID;

             var curRowInfo = '(' + $translate.instant('RowIndex').formatObj({
                 rowIndex: m.Index
             }) + ')' +
              $translate.instant('JournalPZH') + ':' + tempVID + ',' +
              $translate.instant('JournalPZLX') + ':' + tempGroup + ',' +
              $translate.instant('JournalFLH') + '：' + tempItemID + ';<br />';
             //凭证号为空
             if (PWC.isNullOrEmpty(m.VID)) {
                 VIDEmptyCheckCount++;
                 VIDEmptyCheckMsg += curRowInfo;
             } else {
                 //如果凭证号超过50个字符
                 if (m.VID.length > constant.validateLength.StringLength_50) {
                     stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({
                         rowIndex: m.Index
                     }) + ')' + $translate.instant('JournalPZH') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                     stringOverLengthCheckCount++;
                 }
             }

             if (PWC.isNullOrEmpty(m.Group)) {
                 groupEmptyCheckCount++;
                 groupEmptyCheckMsg += curRowInfo;
             } else {
                 //如果凭证类型超过50个字符
                 if (m.Group.length > constant.validateLength.StringLength_50) {
                     stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({
                         rowIndex: m.Index
                     }) + ')' + $translate.instant('JournalPZLX') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                     stringOverLengthCheckCount++;
                 }
             }
             

             if (PWC.isNullOrEmpty(m.ItemID)) {
                 itemEmptyCheckCount++;
                 itemEmptyCheckMeg += curRowInfo;
             } else {
                 //如果分录号超过50个字符
                 if (m.ItemID.length > constant.validateLength.StringLength_50) {
                     stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({
                         rowIndex: m.Index
                     }) + ')' + $translate.instant('JournalFLH') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                     stringOverLengthCheckCount++;
                 }
             }
             

             //科目代码为空
             if (PWC.isNullOrEmpty(m.AcctCode)) {
                 AcctCodeEmptyCheckCount++;
                 AcctCodeEmptyCheckMsg += curRowInfo;
             } else {
                 //如果科目代码超过50个字符
                 if (m.AcctCode.length > constant.validateLength.StringLength_50) {
                     stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({
                         rowIndex: m.Index
                     }) + ')' + $translate.instant('JournalKMDM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                     stringOverLengthCheckCount++;
                 }
             }

             //凭证日期为空
             if (PWC.isNullOrEmpty(m.Date)) {
                 VoucherDateEmptyErrorCount++;
                 VoucherDateEmptyErrorMsg += curRowInfo;
             } else {
                 //凭证日期格式错误
                 if (!PWC.checkDate(m.Date)) {
                     VourcharDateFormatErrorMsg += curRowInfo;
                     VourcharDateFormatErrorCount++;
                 }
             }

             //验证金额
             if (isNaN(parseFloat(m.Debit)) || isNaN(parseFloat(m.Credit))) {
                 AmountFormatErrorMsg += curRowInfo;
                 AmountFormatErrorCount++;
             } else {
                 //如果在规定的数值范围外，则提示错误
                 if (parseFloat(m.Debit) < constant.startNum || parseFloat(m.Debit) > constant.endNum) {
                     numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({
                         rowIndex: m.Index
                     }) + ')' + $translate.instant('JournalJFJE') + $translate.instant('NumOverLengthMsg') + '<br />';
                     numOutRangeCheckCount++;
                 } else {
//                     m.Debit = PWC.round(m.Debit, 2);//todo:skip round to ben open future (neo)
                 }
                 //如果在规定的数值范围外，则提示错误
                 if (parseFloat(m.Credit) < constant.startNum || parseFloat(m.Credit) > constant.endNum) {
                     numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({
                         rowIndex: m.Index
                     }) + ')' + $translate.instant('JournalDFJE') + $translate.instant('NumOverLengthMsg') + '<br />';
                     numOutRangeCheckCount++;
                 } else {
//                     m.Credit = PWC.round(m.Credit, 2);//todo:skip round to ben open future (neo)
                 }
             }

             //验证期间为正整数
             if (!PWC.isNullOrEmpty(m.Period)) {
                 if (!PWC.isPositiveInteger(m.Period)) {
                     PeriodFormatErrorMsg += curRowInfo;
                     PeriodFormatErrorCount++;
                 } else {
                     if (m.Period < 1 || m.Period > 12) {
                         numOutRangeCheckCount++;
                         numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({
                             rowIndex: m.Index
                         }) + ')' + $translate.instant('JournalQJ') + $translate.instant('PeriodOverLengthMsg') + ';<br />';
                     }
                 }
             }

             //验证客户代码不能超过50个字符
             if (!PWC.isNullOrEmpty(m.CustomerCode) && m.CustomerCode.length > constant.validateLength.StringLength_50) {
                 stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({
                     rowIndex: m.Index
                 }) + ')' + $translate.instant('JournalKHDM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                 stringOverLengthCheckCount++;
             }

             //摘要不能超过200个字符
             if (!PWC.isNullOrEmpty(m.Summary) && m.Summary.length > constant.validateLength.StringLength_200) {
                 stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({
                     rowIndex: m.Index
                 }) + ')' + $translate.instant('JournalZY') + $translate.instant('OutputStringLengthMsg_200') + ';<br />';
                 stringOverLengthCheckCount++;
             }
         });
         //#endregion 

         //#region 添加错误信息到错误列表

         //push凭证号空信息到错误列表
         if (VIDEmptyCheckCount > 0) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.JournalEntryVIDEmptyErrorType,
                 'errorCount': VIDEmptyCheckCount,
                 'errorContent': VIDEmptyCheckMsg
             });
         }

         if (AcctCodeEmptyCheckCount > 0) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.JournalEntryAcctCodeEmptyErrorType,
                 'errorCount': AcctCodeEmptyCheckCount,
                 'errorContent': AcctCodeEmptyCheckMsg
             });
         }
         if (VoucherDateEmptyErrorCount > 0) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.JournalEntryVoucherDateEmptyErrorType,
                 'errorCount': VoucherDateEmptyErrorCount,
                 'errorContent': VoucherDateEmptyErrorMsg
             });
         }
         if (VourcharDateFormatErrorCount) {
             result = false;
             //凭证日期格式错误
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.JournalEntryDateFormatErrorType,
                 'errorCount': VourcharDateFormatErrorCount,
                 'errorContent': VourcharDateFormatErrorMsg
             });
         }
         //金额格式错误
         if (AmountFormatErrorCount) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.JournalEntryAmountErrorType,
                 'errorCount': AmountFormatErrorCount,
                 'errorContent': AmountFormatErrorMsg
             });
         }
         //验证期间为正整数
         if (PeriodFormatErrorCount) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.JournalEntryPeriodFormatErrorType,
                 'errorCount': PeriodFormatErrorCount,
                 'errorContent': PeriodFormatErrorMsg
             });
         }
         //push字符串过长的错误信息到错误列表
         if (stringOverLengthCheckCount > 0) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.OutputStringLengthType,
                 'errorCount': stringOverLengthCheckCount,
                 'errorContent': stringOverLengthCheckMsg
             });
         }
         //push数值超过范围的错误信息到列表
         if (numOutRangeCheckCount > 0) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.NumOutRangeErrorType,
                 'errorCount': numOutRangeCheckCount,
                 'errorContent': numOutRangeCheckMsg
             });
         }



         if (groupEmptyCheckCount > 0) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.JournalEntryGroupEmptyErrorType,
                 'errorCount': groupEmptyCheckCount,
                 'errorContent': groupEmptyCheckMsg
             });
         }

         if (itemEmptyCheckCount > 0) {
             result = false;
             $scope.errorMsgMap.push({
                 'errorType': validationErrorType.JournalEntryItemIDEmptyErrorType,
                 'errorCount': itemEmptyCheckCount,
                 'errorContent': itemEmptyCheckMeg
             });
         }

         //#endregion
         return result;
     };


     //4:筛选符合期间条件的数据进库
     var FilterPeriodData = function (journalEntryList) {
         //存放筛选后的数据
         $scope.journalEntryListFilter = [];
         if ($.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap) > -1) {
             $scope.MapPeriodFlag = true; //是否对应了期间列           

             journalEntryList.forEach(function (item) {
                 //截断过长的内容
                 item.Group = item.Group.substring(0, constant.validateLength.StringLength_50);
                 item.VID = item.VID.substring(0, constant.validateLength.StringLength_256);
                 item.AcctCode = item.AcctCode.substring(0, constant.validateLength.StringLength_50);
                 $scope.journalEntryListFilter.push(item);
             });
         } else {
             $scope.MapPeriodFlag = false; //是否对应了期间列
             journalEntryList.forEach(function (item) {
                 //截断过长的内容
                 item.Group = item.Group.substring(0, constant.validateLength.StringLength_50);
                 item.VID = item.VID.substring(0, constant.validateLength.StringLength_256);
                 item.AcctCode = item.AcctCode.substring(0, constant.validateLength.StringLength_50);
                 $scope.journalEntryListFilter.push(item);
             });
             $scope.journalEntryListFilter = journalEntryList;
         }
     };


     //点击导入按钮时，进行导入操作
     var importJournalEntryData = function (importType) {
         //todo:
         if (citSessionService.project.projectStatusList[curPeriod] >= constant.ProjectStatusEnum.Generated) {
             swal({
                 title: "warning!",
                 text: $translate.instant('IsConfirmToReImport').formatObj({
                     status: vatCommonService.getProjectStautsEnumDesc(citSessionService.project.projectStatusList[curPeriod])
                 }),
                 type: "warning",
                 showCancelButton: true,
                 confirmButtonColor: "#DD6B55",
                 confirmButtonText: $translate.instant('Yes'),
                 cancelButtonText: $translate.instant('No'),
                 closeOnConfirm: true,
                 closeOnCancel: true
             },
              function (isConfirm) {
                  if (isConfirm) {
                      doImportJournalEntryData(importType);
                  } else {
                      swal.close();
                  }
              });
         } else {
             doImportJournalEntryData(importType);
         }
     };


     var doImportJournalEntryData = function (importType) {
         if (!$scope.fileName) {
             SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
             return;
         }

         var importType = importType; //0：第一次导入，1：覆盖导入，2：追加导入

         //设置数据导入时的起始行,默认设置从第一行开始
         var startRowNum = 1;
         if ($('#StartRowNum').val()) {
             startRowNum = $('#StartRowNum').val();
         }

         //验证前，将错误数据清空
         $scope.errorMsgMap = [];

         //1：判断是否有没有map的必须列和起始行输入格式是否正确
         if (!ColumnsMapCheck()) {
             $('#errorListModal').modal('show');
             return;
         }

         //将需要导入的数据组装到list中
         var inputJournalEntryList = [];

         vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, constant.allDataPageSize)
          .success(function (data) {
              var allSheetData = data.dataList;
              for (var i = startRowNum - 1; i < allSheetData.length; i++) {
                  var journalEntryInfo = {
                      'Index': i + 1, //行号
                      'Period': allSheetData[i][$.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap)], //期间
                      'Date': allSheetData[i][$.inArray($translate.instant('JournalPZRQ'), $scope.selectedColumnMap)], //凭证日期
                      'Group': allSheetData[i][$.inArray($translate.instant('JournalPZLX'), $scope.selectedColumnMap)], //凭证类型
                      'VID': allSheetData[i][$.inArray($translate.instant('JournalPZH'), $scope.selectedColumnMap)], //凭证号
                      'ItemID': allSheetData[i][$.inArray($translate.instant('JournalFLH'), $scope.selectedColumnMap)], //分录号
                      'AcctCode': allSheetData[i][$.inArray($translate.instant('JournalKMDM'), $scope.selectedColumnMap)], //科目代码
                      'Summary': $.inArray($translate.instant('JournalZY'), $scope.selectedColumnMap) > -1 ?
                       allSheetData[i][$.inArray($translate.instant('JournalZY'), $scope.selectedColumnMap)] : null, //摘要
                      'Debit': PWC.isNullOrEmpty(allSheetData[i][$.inArray($translate.instant('JournalJFJE'), $scope.selectedColumnMap)]) ?
                       0 : allSheetData[i][$.inArray($translate.instant('JournalJFJE'), $scope.selectedColumnMap)], //如果金额为空，则设置为0
                      'Credit': PWC.isNullOrEmpty(allSheetData[i][$.inArray($translate.instant('JournalDFJE'), $scope.selectedColumnMap)]) ?
                       0 : allSheetData[i][$.inArray($translate.instant('JournalDFJE'), $scope.selectedColumnMap)], //如果金额为空，则设置为0
                      'CustomerCode': $.inArray($translate.instant('JournalKHDM'), $scope.selectedColumnMap) > -1 ?
                       allSheetData[i][$.inArray($translate.instant('JournalKHDM'), $scope.selectedColumnMap)] : null, //如果用户对应了客户代码，则保存用户对应的客户代码数据，否则保存为null
                      'ImportType': enums.vatImportType.journalEntry, //导入类型
                      'MonthID': $.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap) > -1 ?
                       allSheetData[i][$.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap)] : null //如果用户对应了期间字段，则保存用户对应的期间，否则保存为null
                  };
                  inputJournalEntryList.push(journalEntryInfo);
              }


              //前台数据验证
              FrontEndValidJournalEntryData(inputJournalEntryList);

              if ($scope.errorMsgMap.length > 0) {
                  $('#errorListModal').modal('show');
                  return;
              } else {
                  logDto.ID = PWC.newGuid();
                  logDto.CreateTime = new Date();
                  logDto.UpdateTime = new Date();
                  logDto.OperationContent = $scope.fileName;
                  if (importType === $scope.importEnum.Import) {
                      logDto.OperationName = $translate.instant('ImportJournalEntry');
                      logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
                  } else if (importType === $scope.importEnum.CoverImport) {
                      logDto.OperationName = $translate.instant('CoverImportJournalEntry');
                      logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
                  } else if (importType === $scope.importEnum.AddImport) {
                      logDto.OperationName = $translate.instant('AddImportJournalEntry');
                      logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
                  }

                  var servicePeriods = [];
                  if ($scope.serviceTypeId === constant.serviceType.CIT) {
                      servicePeriods = _.chain($scope.journalEntryListFilter).map(function (item) { return item.PeriodId }).uniq().value();
                  }
                  else if ($scope.serviceTypeId === constant.serviceType.VAT) {
                      servicePeriods = [curPeriod];
                  }

                  var queryImportDto = {
                      serviceTypeId: $scope.serviceTypeId,
                      periods: servicePeriods,
                      projectId: projectID
                  }


                  vatImportService.getProjectImportType(queryImportDto).success(function (re) {
                      if (re.result) {
                          var periodInforData = re.data;
                          var notImported = _.find(periodInforData, function (item) {
                              return item.importType === enums.projectImportType.UnImported;
                          });
                          var erpImported = _.find(periodInforData, function (item) {
                              return item.importType === enums.projectImportType.ErpImported;
                          });

                          if (!_.isUndefined(notImported) && notImported.length === periodInforData.length) { //没有导入过tb或者erp。则提示需要先导入TB
                              SweetAlert.warning($translate.instant('JournalEntryImportErrorNotImportTBData'));
                          } else if (!_.isUndefined(erpImported)) { //有任一期间导入过erp，则提示不能导入
                              SweetAlert.warning($translate.instant('JournalEntryImportErrorERPDataImportedAlready'));
                          } else {
                              //如果没有选择期间，则系统给出导入所有数据的提示，确认后数据进库，否则，取消导入操作
                              if (!$scope.MapPeriodFlag) {
                                  swal({
                                      title: "warning!",
                                      text: $translate.instant('NoPeriod'),
                                      type: "warning",
                                      showCancelButton: true,
                                      confirmButtonColor: "#DD6B55",
                                      confirmButtonText: $translate.instant('Yes'),
                                      cancelButtonText: $translate.instant('No'),
                                      closeOnConfirm: true,
                                      closeOnCancel: true
                                  },
                                   function (isConfirm) {
                                       if (isConfirm) {
                                           //数据进库
                                           vatImportService.importJournalEntryData($scope.journalEntryListFilter, importType).success(function () {
                                               logDto.UpdateState = $translate.instant('ImportSuccess');
                                               vatOperationLogService.addOperationLog(logDto);
                                               //todo
                                               vatCommonService.setProjectStatus(projectDbName, curPeriod, constant.ProjectStatusEnum.Imported, constant.DictionaryDictKey.WFImportJournalEntry, enums.FinishStatusEnum.Finished);
                                               vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, true);
                                               //$log.debug("import entry importJournalEntryData: " + citSessionService.project.importSubStatus.isEntryImport);
                                               SweetAlert.success($translate.instant('ImportSuccess'));
                                               loadJournalEntryDataFromDB();
                                               $scope.fileName = '';
                                               citSessionService.dataChanged = false; //设置为false表示在切换页面前数据没有变更,不需要提示
                                           }).error(function () {
                                               logDto.UpdateState = $translate.instant('ImportFail');
                                               vatOperationLogService.addOperationLog(logDto);
                                           });
                                       }
                                   });
                              } else {
                                  //数据进库
                                  vatImportService.importJournalEntryData($scope.journalEntryListFilter, importType).success(function () {
                                      logDto.UpdateState = $translate.instant('ImportSuccess');
                                      vatOperationLogService.addOperationLog(logDto);
                                      //todo
                                      vatCommonService.setProjectStatus(projectDbName, curPeriod, constant.ProjectStatusEnum.Imported, constant.DictionaryDictKey.WFImportJournalEntry, enums.FinishStatusEnum.Finished);
                                      vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, true);
                                      //$log.debug("import entry importJournalEntryData: " + citSessionService.project.importSubStatus.isEntryImport);
                                      SweetAlert.success($translate.instant('ImportSuccess'));
                                      loadJournalEntryDataFromDB();
                                      $scope.fileName = '';
                                      citSessionService.dataChanged = false; //设置为false表示在切换页面前数据没有变更,不需要提示
                                  }).error(function () {
                                      logDto.UpdateState = $translate.instant('ImportFail');
                                      vatOperationLogService.addOperationLog(logDto);
                                  });
                              }
                          }
                      }

                  }).error(function () {
                      SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                  });
              }

          });
     }


     //获取验证信息
     var getValidationList = function () {
         var deferred = $q.defer();
         vatImportService.getValidationDtoInfo(enums.validationType.JournalEntry, curPeriod).success(function (data) {
             if (data.length > 0) {
                 var index = 1;
                 data.forEach(function (v) {
                     v.index = index++;
                 });
                 $scope.errorList = data;
                 $scope.gridOptionsErrorMsg.data = data;
             } else {
                 $scope.errorList = [];
                 $scope.gridOptionsErrorMsg.data = [];
             }
             deferred.resolve();
         });

         return deferred.promise;
     }


     var showErrTab = function () {
         $scope.ImportErrorTab = true; //默认显示顶部block
         $scope.ImportErrorTag = true; //默认隐藏下方的错误信息列表
         $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({
             "NumberOfError": $scope.errorList.length
         });

     };


     var setErrorWrapCssDefault = function () {
         $('#content-resizer').css('bottom', '10px');

         $('#topIcon').css({
             bottom: '-501px'
         });

         $('.error-info-wrapper').css('height', '0px');
     };

     
     //显示图标
     var errorLevelToString = function (errorLevel) {
         if (errorLevel === 0) {
             return '/app-resources/images/vat/error.png';
         }
         if (errorLevel === 1) {
             return '/app-resources/images/vat/warning.png';
         }
         if (errorLevel === 2) {
             return '/app-resources/images/vat/tips.png';
         } else {
             return '/app-resources/images/vat/tips.png';
         }
     };


     //显示分录明细
     var showJournalEntryModal = function (typeid, items) {
         var data = JSON.parse(items);
         $scope.devgridDataSource = data;
         //组装列
         var columns = [];
         columns.push({
             caption: $translate.instant('JournalPZRQ'),
             dataField: "Date",
             dataType: "date",
             width: 100
         });
         //如果期间不为null，则加入期间列
         if (data[0].Period != null) {
             columns.push({
                 caption: $translate.instant('JournalQJ'),
                 dataField: "Period",
                 width: 50
             });
         }
         columns.push({
             caption: $translate.instant('JournalPZLX'),
             dataField: "Group",
             width: 160
         }, {
             caption: $translate.instant('JournalPZH'),
             dataField: "VID",
             width: 130
         }, {
             caption: $translate.instant('JournalKMDM'),
             dataField: "AcctCode",
             width: 100
         });
         //如果摘要不为null，则加入摘要列
         if (data[0].Summary != null) {
             columns.push({
                 caption: $translate.instant('JournalZY'),
                 dataField: "Summary",
                 width: 150
             });
         }
         columns.push({
             caption: $translate.instant('JournalJFJE'),
             dataField: "Debit",
             format: {
                 type: 'fixedPoint',
                 precision: 2
             },
             width: 100
         }, {
             caption: $translate.instant('JournalDFJE'),
             dataField: "Credit",
             format: {
                 type: 'fixedPoint',
                 precision: 2
             },
             width: 100
         }, {
             caption: $translate.instant('JournalKHDM'),
             dataField: "CustomerCode",
             width: 100
         }, {
             caption: $translate.instant('JournalFLH'),
             dataField: "ItemID",
             width: 70
         });


         //如果不是重复数据，就展示普通明细弹出框，否则就显示重复数据明细弹出框
         if (typeid !== 52) {
             $scope.gridJournalEntryItemGridOptions = {
                 columns: columns,
                 selection: {
                     mode: "single"
                 },
                 bindingOptions: {
                     "dataSource": "devgridDataSource"
                 },
                 scrolling: {
                     mode: "standard",
                     showScrollbar: "always"
                 },
                 hoverStateEnabled: true,
                 paging: {
                     pageSize: 10
                 }
             }
             $('#jounarEntryItemModal').modal('show');
         } else {
             $scope.deferStatus = true;
             $scope.filterCondition = ["IsDuplicate", "=", true];

             $scope.gridJournalEntryDuplicateItemGridOptions = {
                 columns: columns,
                 bindingOptions: {
                     "dataSource.store.data": "devgridDataSource",
                     "selection.deferred": "deferStatus",
                     "selectionFilter": "filterCondition"
                 },
                 dataSource: {
                     store: {
                         type: "array",
                         key: 'VoucherID'
                     }
                 },
                 selection: {
                     selectAllMode: "allPages",
                     showCheckBoxesMode: "always",
                     mode: "multiple"
                 },
                 scrolling: {
                     mode: "standard",
                     showScrollbar: "always"
                 },
                 hoverStateEnabled: true,
                 paging: {
                     pageSize: 10
                 }
             }

             $('#jounarEntryDuplicateItemModal').modal('show');
         }
     };


     //删除重复数据
     var deleteDuplicateData = function () {
         var dataGrid = $('#gridJournalEntryDuplicateItemGrid').dxDataGrid("instance");

         var deleteList = [];
         dataGrid.getSelectedRowsData().done(function (rowData) {
             for (var i = 0; i < rowData.length; i++) {
                 deleteList.push(rowData[i].AcctCode);
             }
         });



         dataGrid.getSelectedRowKeys().done(function (keys) {
             if (keys && keys.length === 0) {
                 SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
                 return;
             }

             logDto.ID = PWC.newGuid();
             logDto.CreateTime = new Date();
             logDto.UpdateTime = new Date();
             logDto.OperationContent = deleteList.join(",");
             logDto.OperationName = $translate.instant('DeleteDuplicateData');
             logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

             vatImportService.deleteJournalEntryData(keys).success(function (data) {
                 if (data && data.result) {
                     //删除数据后重新校验          
                     vatImportService.validateJournalEntryByPeriods().success(function () {
                         logDto.UpdateState = $translate.instant('DeleteSuccess');
                         vatOperationLogService.addOperationLog(logDto);

                         loadJournalEntryDataFromDB();
                         $('#jounarEntryDuplicateItemModal').modal('hide');
                         SweetAlert.success($translate.instant('DeleteSuccess'));
                         //获取错误列表信息
                         getValidationList().then(function () {
                             if ($scope.errorList.length > 0) {
                                 showErrTab();
                                 $scope.toggleErrorTab();

                                 //当有错误信息时，显示错误信息表
                                 $scope.showErrorTable = true;
                             } else {
                                 $scope.ImportErrorTab = false;
                                 $scope.ImportErrorTag = false;
                             }
                         });

                     });
                 }
             }).error(function () {
                 logDto.UpdateState = $translate.instant('DeleteFailed');
                 vatOperationLogService.addOperationLog(logDto);
                 SweetAlert.error($translate.instant('PleaseContactAdministrator'));
             });
         });


     };


     //弹出期间选择框，清空数据
     var clearJournalEntryData = function () {
         if (curPeriod === constant.WholeYearPeriod) {
             showPeriodDrapDown();
         }
         else {
             $scope.selectedPeriod = curPeriod;
             startToDeleteJe();
         }
         
     };


     //删除JE
     var startToDeleteJe = function () {
         if (curPeriod === constant.WholeYearPeriod && ( _.isUndefined($scope.selectedPeriod) || _.isNull($scope.selectedPeriod))) {
             SweetAlert.warning($translate.instant('SelectPeriodDelete'));
         } else {
             var alertMsg = curPeriod === constant.WholeYearPeriod ? $translate.instant('JournalEntryClearWarning')
                 : $translate.instant('JournalEntryClearTips')
             swal({
                 title: "warning!",
                 text: alertMsg,
                 type: "warning",
                 showCancelButton: true,
                 confirmButtonColor: "#DD6B55",
                 confirmButtonText: $translate.instant('Yes'),
                 cancelButtonText: $translate.instant('No'),
                 closeOnConfirm: true,
                 closeOnCancel: true
             }, function (isConfirm) {
                 if (isConfirm) {
                     logDto.ID = PWC.newGuid();
                     logDto.CreateTime = new Date();
                     logDto.UpdateTime = new Date();
                     logDto.OperationContent = '';
                     logDto.OperationName = $translate.instant('ClearTrialBalance');
                     logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;

                     vatImportService.clearJournalEntryData($scope.selectedPeriod).success(function (data) {
                         if (data && data.result) {
                             logDto.UpdateState = $translate.instant('ClearSuccess');
                             vatOperationLogService.addOperationLog(logDto);
                             //todo:
                             vatCommonService.clearDataSetProjectStatusSimple(projectDbName, curPeriod, constant.DictionaryDictKey.WFImportJournalEntry, enums.FinishStatusEnum.NotFinished);
                             vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, false);
                             //$log.debug("clear entry clearJournalEntryData: " + citSessionService.project.importSubStatus.isEntryImport);
                             SweetAlert.success($translate.instant('ClearSuccess'));
                             loadJournalEntryDataFromDB();
                             $scope.isShowImportTotalBtn = true;
                         } else {
                             logDto.UpdateState = $translate.instant('ClearFailed');
                             vatOperationLogService.addOperationLog(logDto);
                             SweetAlert.warning($translate.instant('ClearFailed'));
                         }

                         $scope.selectedPeriod = null;
                         if (curPeriod === constant.WholeYearPeriod) {
                             $scope.closePeriodSelectModal();
                         }
                         

                     }).error(function () {
                         logDto.UpdateState = $translate.instant('ClearFailed');
                         vatOperationLogService.addOperationLog(logDto);
                         $scope.selectedPeriod = null;
                         if (curPeriod === constant.WholeYearPeriod) {
                             $scope.closePeriodSelectModal();
                         }
                         SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                     });
                 }

             });
         }
     }


     //刷新数据，实质是重新校验数据
     var refreshJournalEntryData = function () {
         logDto.ID = PWC.newGuid();
         logDto.CreateTime = new Date();
         logDto.UpdateTime = new Date();
         logDto.OperationContent = '';
         logDto.OperationName = $translate.instant('RefreshValidationData');
         logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;

         vatImportService.validateJournalEntryByPeriods().success(function () {
             logDto.UpdateState = $translate.instant('RefreshSuccess');
             vatOperationLogService.addOperationLog(logDto);

             loadJournalEntryDataFromDB();
             //获取错误列表信息
             getValidationList().then(function () {
                 if ($scope.errorList.length > 0) {
                     showErrTab();
                     $scope.toggleErrorTab();

                     //当有错误信息时，显示错误信息表
                     $scope.showErrorTable = true;
                 } else {
                     $scope.ImportErrorTab = false;
                     $scope.ImportErrorTag = false;
                 }
             });

         }).error(function () {
             logDto.UpdateState = $translate.instant('RefreshTbFail');
             vatOperationLogService.addOperationLog(logDto);

             SweetAlert.error($translate.instant('PleaseContactAdministrator'));
         });;
     };


     //日志
     var showOperateLogPop = function () {
         $scope.isShowLog = true;
     };


     var initPagingControl = function (totalItemsCount) {
         $scope.pagingOptions.totalItems = totalItemsCount;
     }


     //显示期间选择弹出框
     var showPeriodDrapDown = function () {
         $scope.modalInstance = $uibModal.open({
             animation: false,
             ariaLabelledBy: 'modal-title',
             ariaDescribedBy: 'modal-body',
             templateUrl: 'je-model-period-dropdown.html',
             scope: $scope,
             windowClass: "je-model-period-dropdow-popup"
         });

         $scope.closePeriodSelectModal = function () {
             $scope.modalInstance.dismiss('cancel');
         };

         $scope.selectBox = {
             simple: {
                 dataSource: $scope.jePeriods,
                 displayExpr: "Period",
                 valueExpr: "ID",
                 searchEnabled: false,
                 placeholder: $translate.instant('PleaseSelectPeriod'),
                 noDataText: $translate.instant('NoDataToDispaly'),
                 maxLength: 2,
                 onSelectionChanged: function (e) {
                     $log.debug(e);
                     $scope.selectedPeriod = e.selectedItem.Period;
                 }
             }
         };

         vatImportService.getJePeriods().success(function (re) {
             if (re.result) {
                 $scope.jePeriods = [];
                 var id = 1;
                 $.each(re.data, function (index, item) {
                     var periodDto = {
                         ID: -1,
                         Period: -1
                     };
                     periodDto.ID = id++;
                     periodDto.Period = item;
                     $scope.jePeriods.push(periodDto);
                 });

                 $("#jePeriodSelectBox").dxSelectBox("instance").option("dataSource", $scope.jePeriods);
             }

         }).error(function () {
             SweetAlert.error($translate.instant('PleaseContactAdministrator'));
         });
     }


     //编辑状态时，按钮区域的样式
     var setButtonWrapStyle = function () {
         if ($scope.showImportTable) {
             return { width: "100%" };
         }
     };


     //初始化错误提示grid
     var initErrorMsgGrid = function () {

         $scope.gridOptionsErrorMsg = {
             enableColumnResizing: true,
             rowHeight: constant.UIGrid.rowHeight,
             selectionRowHeaderWidth: constant.UIGrid.rowHeight,
             enableSorting: false,
             enableColumnMenus: false,
             virtualizationThreshold: 50, //默认加载50条数据，避免在数据展示时，只显示前面4条
             enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
             enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
             columnDefs: [{
                 name: ' ',
                 width: '5%',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
             }, {
                 name: $translate.instant('ImportErrorPopUpNoCol'),
                 width: '5%',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
             }, {
                 name: $translate.instant('ErrorResult'),
                 width: '30%',
                 cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
             },

              {
                  name: $translate.instant('ImportErrorPopUpErrorCountCol'),
                  width: '10%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
              },

              {
                  name: $translate.instant('InvoiceQJ'),
                  width: '5%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodId}}<span></div>'
              }, {
                  name: $translate.instant('ErrorDetail'),
                  width: '10%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><a ng-click="grid.appScope.showJournalEntryModal(row.entity.erpCheckTypeId, row.entity.validationDetails)">{{"ViewDetails" | translate}}</a></div>'
              }, {
                  name: $translate.instant('ValidationTips'),
                  width: '35%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.validationTips}}" data-ng-bind-html="row.entity.validationTips"></span></div>'
              }

             ],
             onRegisterApi: function (gridApi) {
                 $scope.errorGridApi = gridApi;

                 $interval(function () {
                     $scope.errorGridApi.core.handleWindowResize();
                 }, 500, 60 * 60 * 8);
             }
         };
     };
     

     //初始化JE展示grid
     var initJeGrid = function () {
         $scope.gridOptionsJournalEntry = {
             enableColumnResizing: true,
             rowHeight: constant.UIGrid.rowHeight,
             //selectionRowHeaderWidth: constant.UIGrid.rowHeight,
             enableSorting: false,
             enableColumnMenus: false,
             flatEntityAccess: true,
             //virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
             //enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
             //enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
             onRegisterApi: function (gridApi) {
                 $scope.gridApi = gridApi;

                 $interval(function () {
                     $scope.gridApi.core.handleWindowResize();
                 }, 500, 60 * 60 * 8);
             }
         };
     };


     $scope.getGridHeight = function () {
         if ($scope.isLoadComplete) {
             return {
                 height: ($('.journal-entry-grid-wrapper').height()) + "px"
             };
         } else {
             return {
                 height: 0 + "px"
             };
         }
     };


     $scope.toggleErrorTab = function () {
         $scope.ImportErrorTag = !$scope.ImportErrorTag;

         // topIcon and content-resize gapBottom 15px
         if (!$scope.ImportErrorTag) {
             setErrorWrapCssDefault();
         } else {

             if (parseInt($('#content-resizer').css('bottom')) < 100) {
                 $('#content-resizer').css('bottom', '130px');

                 $('#topIcon').css({
                     bottom: '-381px'
                 });

                 $('.error-info-wrapper').css('height', '130px');
             }
         }
     };


     $scope.getErrorGridHeight = function () {
         if ($scope.isLoadComplete) {
             var y = $("#error-info-wrapper").height();

             // Enough space
             if (y > constant.UIGrid.gapHeight) {
                 y = y - constant.UIGrid.gapHeight;
                 return {
                     height: y + "px"
                 };
             } else {

                 return {
                     height: '0px'
                 };
             }
         }

         return {};
     };


     $scope.pagingService = {
         refreshInvoiceDataGrid: function () {
             $log.debug("refreshInvoiceDataGrid");
             loadJournalEntryDataFromDB();
         },
     };

     
     (function initialize() {
         $log.debug('importJournalEntryController.ctor()...');

         $scope.errorMsgMap = [];
         $scope.journalEntryFileName = '';
         $scope.selectedColumnMap = [];
         $scope.journalEntryColumns = [];
         $scope.initJournalEntryColumnsIndex = [];
         $scope.startRowList = [];
         $scope.isShowImportTotalBtn = true;
         $scope.changeJournalEntrySheet = changeJournalEntrySheet;
         $scope.mappingColumn = mappingColumn;
         $scope.importJournalEntryData = importJournalEntryData;
         $scope.errorLevelToString = errorLevelToString;
         $scope.showJournalEntryModal = showJournalEntryModal;
         $scope.deleteDuplicateData = deleteDuplicateData;
         $scope.clearJournalEntryData = clearJournalEntryData;
         $scope.refreshJournalEntryData = refreshJournalEntryData;
         $scope.showOperateLogPop = showOperateLogPop;
         $scope.startToDeleteJe = startToDeleteJe;
         $scope.setButtonWrapStyle = setButtonWrapStyle;
         $scope.sheetData = {
             sheetNameList: [],
             dataList: [],
             selectedSheetIndex: 0
         };
         $scope.sheetInfo = {
             selectedSheetName: '',
             selectedSheetIndex: 0,
             topRowNumber: 0
         };

         initErrorMsgGrid();
         initJeGrid();
         initColumns();
         loadJournalEntryDataFromDB();
                
         $scope.$watch('journalEntryFileName', function (newValue, oldValue) {
             if (newValue && newValue !== oldValue) {
                 updateJournalEntryFileName(newValue);
                 doUploadJournalEntryFile($scope.journalEntryFileName);
                 $scope.ImportErrorTab = false;
                 $scope.ImportErrorTag = false;
                 $('#StartRowNum').val('2');
                 //$scope.ImportFlag = true;
             }
         });

         $timeout(function () {
             $scope.isLoadComplete = true;
         }, 500);
     })();
 }
]);