﻿commonModule.directive('importJournalEntry', ['$log',
    function ($log) {
        'use strict';
        $log.debug('importJournalEntry.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/common/controls/import/import-journal-entry/import-journal-entry.html' + '?_=' + Math.random(),
            scope: {
                serviceTypeId: "=?",
                periodId: "=?"
            },
            controller: 'importJournalEntryController',
            link: function (scope, element) {

            }
        };
    }
]).filter('propsFilter', function () {
    return function (items, props) {
        var out = [];

        if (angular.isArray(items)) {
            var keys = Object.keys(props);

            items.forEach(function (item) {
                var itemMatches = false;

                for (var i = 0; i < keys.length; i++) {
                    var prop = keys[i];
                    var text = props[prop].toLowerCase();
                    if (!_.isUndefined(item[prop])) {
                        if (item[prop].toString().toLowerCase().indexOf(text) !== -1) {
                            itemMatches = true;
                            break;
                        }
                    }                  
                }

                if (itemMatches) {
                    out.push(item);
                }
            });
        } else {
            // Let the output be the input untouched
            out = items;
        }

        return out;
    };
});