﻿commonModule.
controller('indexMultiSelectorController', ['$scope', 'indexAnalysisDetailService',
    function($scope, indexAnalysisDetailService) {

        // 本页面常量
        var thisConstant = {
            indexMultiSelectorTreeView: 'indexMultiSelectorTreeView',
        };

        var treeView;

        // 数据
        var thisData = {
            selectedIndexSet: {},
        };

        // 主模块
        var mainModule = {

            // 加载数据并显示
            loadData: function() {

                if (!$scope.selectIdList) {
                    $scope.selectIdList = [];
                }

                indexAnalysisDetailService.getIndexAnalysisDropDownList().success(function(data) {
                    thisData.indexList = data;
                    mainModule.drawdxDropDownBox(data);
                });
            },

            // 绘制dxDropDownBox
            drawdxDropDownBox: function(dataArray) {

                var syncTreeViewSelection = function(treeView, value) {
                    if (!value) {
                        treeView.unselectAll();
                        return;
                    }

                    value.forEach(function(key) {
                        treeView.selectItem(key);
                    });

                    $scope.selectIndexList = _.filter(thisData.indexList, function(row) {
                        return value.indexOf(row.id) > -1 && !row.parentId;
                    });

                    // console.log(JSON.stringify($scope.selectIndexList));
                };

                $("#" + thisConstant.indexMultiSelectorTreeView).dxDropDownBox({
                    value: $scope.selectIdList,
                    valueExpr: "id",
                    displayExpr: "name",
                    placeholder: "",
                    showClearButton: true,
                    dataSource: dataArray,
                    contentTemplate: function(e) {
                        var value = e.component.option("value"),
                            $treeView = $("<div>").dxTreeView({
                                dataSource: e.component.option("dataSource"),
                                dataStructure: "plain",
                                keyExpr: "id",
                                parentIdExpr: "parentId",
                                selectionMode: "multiple",
                                displayExpr: "name",
                                selectByClick: true,
                                onContentReady: function(args) {
                                    syncTreeViewSelection(args.component, value);
                                },
                                selectNodesRecursive: true,
                                showCheckBoxesMode: "normal",
                                onItemSelectionChanged: function(args) {
                                    var value = args.component.getSelectedNodesKeys();

                                    e.component.option("value", value);
                                }
                            });

                        treeView = $treeView.dxTreeView("instance");

                        e.component.on("valueChanged", function(args) {
                            var value = args.value;
                            syncTreeViewSelection(treeView, value);
                        });

                        return $treeView;
                    }
                });
            },

        };

        (function() {
            mainModule.loadData();

        })();

    }
]);
