﻿commonModule.directive('orgGeneralInfo', ['$log', '$compile', '$timeout', '$interval',
    function ($log, $compile, $timeout, $interval) {
        'use strict';
        $log.debug('orgGeneralInfo.ctor()...');

        return {
            restrict: 'AE',
            templateUrl: '/app/common/controls/org-general-info/org-general-info.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                orgIdGeneralInfo: '=',
                isRenderCompletedGeneralInfo: '='
            },
            controller: 'OrgGeneralInfoController',
            link: function (scope, element) {

                $(".org-general-info").draggable({ containment: "parent", cursor: "cursor" });


                scope.$watch('orgIdGeneralInfo', function (newValue, oldValue) {
                    if (newValue) {
                        //refresh ui grid with new data
                        scope.getGeneralInfo(newValue).then(function (row) {

                            scope.isRenderCompletedGeneralInfo = true;
                        });
                    }
                });

                var orgCityAreaUserPop, orgUserListPop, row, oldOrgId, oldOprType;

                // 显示机构 区域和行业的卡片
                //var showCard = function (pop, row, topOffset, leftOffset) {

                //    pop.css("display", "block").css("top", (function (r) {

                //        if (r.offset().top > window.innerHeight - pop.height())
                //            return r.offset().top - topOffset;
                //        else
                //            return r.offset().top - topOffset;
                //    })(row)).css("left", (function (r) {

                //        if (r.offset().left + r.width() > window.innerWidth - pop.width())
                //            return r.offset().left - leftOffset;
                //        else
                //            return r.offset().left - leftOffset;
                //    })(row)).show();

                //    $(document).one('click', function () {
                //        pop.hide();
                //        orgCityAreaUserPop.hide();
                //        orgUserListPop.hide();
                //    });
                //};

                var showCard = function (pop, row, topOffset, leftOffset,self) {

                    var $popover = pop.show();
                    var pos = $.PositionCalculator({
                        target: this,
                        targetAt: 'top right',
                        item: $popover,
                        itemAt: 'top left',
                        flip: 'both'
                    }).calculate();

                    $popover.css({
                        top: parseInt($popover.css('top')) + pos.moveBy.y + 'px',
                        left: parseInt($popover.css('left')) + pos.moveBy.x + 'px'
                    });

                    $(document).one('click', function () {
                        pop.hide();
                        orgCityAreaUserPop.hide();
                        orgUserListPop.hide();
                    });
                };

                //先判断directive中的uigrid是否渲染完成，如果完成那么就显示card
                scope.$watch('isRenderCompletedCityAreaUser', function (newValue, oldValue) {
                    if (newValue !== undefined && oldValue !== undefined) {
                        showCard(orgCityAreaUserPop, row, 258, 677);
                    }

                });

                scope.$watch('isRenderCompletedUserList', function (newValue, oldValue) {
                    if (newValue !== undefined && oldValue !== undefined) {
                        showCard(orgUserListPop, row, 258, 661);
                    }

                });


                $(".close-card").on("click", function (e) {
                    scope.isRenderCompletedGeneralInfo = false;
                });

                //点击弹出的面板，禁止冒泡事件
                $("#orgGeneralInfoPop").on("click", function (e) {

                    e.stopPropagation();
                });

                //$('.general-tmpl').click(function () {

                //    orgCityAreaUserPop = $("#orgCityAreaUserPop");
                //    orgUserListPop = $('#orgUserListPop');

                //    row = $(this);
                //    var orgId = row.find('#OrgID').text();
                //    var oprType = row.find('#OrgID').attr('data-opr-type');

                //    if (oprType === 'enum.orgCityAreaUserOpr') {

                //        orgUserListPop.hide();

                //        //如果两个值不同，说明点击的是不同的机构，
                //        //需要给orgId赋值触发directive的watch更新uigrid的数据
                //        if (orgId !== oldOrgId || oprType !== oldOprType) {
                //            scope.isRenderCompletedCityAreaUser = false;
                //            scope.orgIdCityAreaUser = orgId + '|' + Math.random();  ////会触发directive的watch操作，从而更新数据
                //        } else {
                //            // 如果点击的是同一个子公司，需要直接显示
                //            //showCard(pop, row);
                //            orgCityAreaUserPop.toggle();

                //            if (orgCityAreaUserPop.is(':visible')) {
                //                //如果当前是可视的那么再绑定一次
                //                $(document).one('click', function () {
                //                    orgCityAreaUserPop.hide();
                //                });
                //            }
                //        }

                //        oldOrgId = orgId;
                //        oldOprType = oprType;

                //    } else if (oprType === 'enum.orgUserList') {

                //        orgCityAreaUserPop.hide();

                //        // 如果两个值不同，说明点击的是不同的机构，
                //        // 需要给orgId赋值触发directive的watch更新uigrid的数据
                //        if (orgId !== oldOrgId || oprType !== oldOprType) {
                //            scope.isRenderCompletedUserList = false;
                //            scope.orgIdUserList = orgId + '|' + Math.random();  ////会触发directive的watch操作，从而更新数据
                //        } else {
                //            // 如果点击的是同一个子公司，需要直接显示
                //            //showCard(pop, row);
                //            orgUserListPop.toggle();

                //            if (orgUserListPop.is(':visible')) {
                //                //如果当前是可视的那么再绑定一次
                //                $(document).one('click', function () {
                //                    orgUserListPop.hide();
                //                });
                //            }
                //        }

                //        oldOrgId = orgId;
                //        oldOprType = oprType;
                //    }
                //});
            }
        };
    }
]);