﻿commonModule.factory('canvasUtil',['$q',function ($q) {
    var dataURLToByteArray = function (dataURL) {
        var BASE64_MARKER = ';base64,';
        if (dataURL.indexOf(BASE64_MARKER) == -1) {
            var parts = dataURL.split(',');
            var contentType = parts[0].split(':')[1];
            var raw = decodeURIComponent(parts[1]);
            return new Blob([raw], { type: contentType });
        }
        var parts = dataURL.split(BASE64_MARKER);
        var contentType = parts[0].split(':')[1];
        var raw = window.atob(parts[1]);
        var rawLength = raw.length;
        var uInt8Array = new Uint8Array(rawLength);
        for (var i = 0; i < rawLength; ++i) {
            uInt8Array[i] = raw.charCodeAt(i);
        }
        //return new Blob([uInt8Array], {type: contentType});
        return uInt8Array;
    };

    var hideElement= function(element)
    {
        var e = document.getElementsByClassName(element);
        for (var i = 0; i < e.length; i++)
        {
            e[i].style.display = 'none';
        }

    };
    var showElement = function (element) {
        var e = document.getElementsByClassName(element);
        for (var i = 0; i < e.length; i++) {
            e[i].style.display = 'block';
        }
    };

    return {
        toBinaryData: function (dom) {
            return dataURLToByteArray(dom.querySelector('canvas').toDataURL());
        },
        saveAsImage: function (name, dom,hiddenElement) {
            hideElement(hiddenElement);
            html2canvas(dom).then(function (canvas) {
                canvas.toBlob(function (blob) {
                    saveAs(blob, name + '.png');
                });
            });
            showElement(hiddenElement);
        },
    };
}]);