﻿commonModule.factory('dictionaryManager', ['$log', 'configurationService', 'loginContext', '$q', 
    function ($log, configurationService, loginContext, $q) {

        $log.debug('dictionaryManager.ctor()...');

        return {
            getDictionaries: function (dictionaryTag) {
                var deferred = $q.defer();
                configurationService.getDictionaries(loginContext.site).success(function (data) {
                    if (data != null && data.length > 0) {
                        var dictionary = _.findWhere(data, { tag: dictionaryTag });
                        if (dictionary) {
                            deferred.resolve(dictionary.values);
                        }
                    }

                    deferred.reject('Cannot find dictionary value by tag ' + dictionaryTag);
                }).error(function () {
                    deferred.reject('Cannot find dictionary value by tag ' + dictionaryTag);

                });
                return deferred.promise;
            }
        };
    }])