﻿commonModule.factory('profileManager', ['$log', 'configurationService', 'loginContext', '$q',
    function ($log, configurationService, loginContext, $q) {

        $log.debug('profileManager.ctor()...');

        var resolve = function (profileName, profiles, deferred) {
            if (profiles != null && profiles.length > 0) {
                var profile = _.findWhere(profiles, { name: profileName });
                if (profile) {
                    deferred.resolve(profile.value);
                    return true;
                }
            }
            return false;
        };


        return {
            getProfileValue: function (profileName) {
                var deferred = $q.defer();
                configurationService.getProfiles(loginContext.userId).success(function (data) {
                    if (resolve(profileName, data.userProiles, deferred))
                        return deferred.promise;
                    if (resolve(profileName, data.roleProiles, deferred))
                        return deferred.promise;
                    if (resolve(profileName, data.siteProiles, deferred))
                        return deferred.promise;
                    if (resolve(profileName, data.systemProiles, deferred))
                        return deferred.promise;
                    deferred.reject("Cannot find profile value!");
                }).error(function () {
                    deferred.reject("Cannot find profile value!");
                });
                return deferred.promise;
            }
        };
    }])