﻿// web service proxy for document hierarchy.
webservices.factory('documentHierarchyService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getDocumentHierarchy: function (documentType) {
            return $http.get('/documenthierarchy?documentType=' + documentType, apiConfig.create());
        },
        getDocumentByCode: function (code) {
            return $http.get('/documenthierarchy/document/'+code, apiConfig.create());
        },
        getDocumentList: function (documentType) {
            return $http.get('/documenthierarchy/documentlist/' + documentType, apiConfig.create()); 
        },
        downloadTemplate : function (documentlist) {
            return $http.post('/documenthierarchy/download/template', { documentlist: documentlist }, apiConfig.create({ responseType: 'arraybuffer' }));
        }
    };
}]);


