﻿// registration web service proxy
webservices.factory('stockService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getStockList: function (param) {
            return $http.post('/stock/getList', param, apiConfig.create());
        },
        updateStock: function (stock) {
            return $http.put('/stock/update', stock, apiConfig.create());
        },
        deleteOrgList: function (stockList, orgID) {
            return $http.post('/stock/delete?orgID=' + orgID, stockList, apiConfig.create());
        },
        addOrgList: function (stockList, orgID) {
            return $http.post('/stock/add?orgID=' + orgID, stockList, apiConfig.create());
        },
        getStockListByOrgID: function (param) {
            return $http.post('/stock/getStockListByOrgID' ,param, apiConfig.create());
        },
        updateOrgList: function (stockList, orgID) {
            return $http.post('/stock/update?orgID=' + orgID, stockList, apiConfig.create());
        },

        //添加变更历史记录
        addHistoryStocks: function (stock) {
            return $http.post('/stock/addHistoryStock', stock, apiConfig.create());
        },
    };
}]);