﻿vatModule.controller('VatAnalysisMenuController', ['$scope', '$rootScope', '$log', '$translate', '$timeout', '$q',
	'SweetAlert', 'vatSessionService',
    function ($scope, $rootScope, $log, $translate, $timeout, $q, SweetAlert, vatSessionService) {
        'use strict';
        $log.debug('VatAnalysisMenuController.ctor()...');

        $scope.menus = [
            { name: '.analyzeReport', text: "出口数据对比", icon: 'glyphicon glyphicon-flag', permission: constant.vatPermission.dataAnalysis.modelAnalysisCode, show: true },
            { name: 'analyzeOrganizeDashboard({id:"' + vatSessionService.project.organizationID + '"})', text: "进项税额差异分析", icon: 'glyphicon glyphicon-stats', permission: constant.vatPermission.dataAnalysis.dashboard.dashboardCode, show: true },
            { name: '.vatTaxDifference', text: $translate.instant('BookTaxDifference'), icon: 'glyphicon glyphicon-tree-conifer', show: true }
        ];
        vatSessionService.querySummayDashboardModel = {
            organizationID: vatSessionService.project.organizationID,
            year: (new Date()).getFullYear(),
            month: (new Date()).getMonth() === 0 ? 12 : (new Date()).getMonth()
        };

        vatSessionService.dashboardSingelOrganizationId = vatSessionService.project.organizationID;

        var analyzeMenuEvent = function (obj) {
            if (obj.menu.text === $translate.instant('Dashboard')) {
                vatSessionService.urlFromAnalyze = true;
                return true;
            }
        };

        (function initialize() {
            $log.debug('VatAnalysisMenuController.initialize()...');
            $scope.analyzeMenuEvent = analyzeMenuEvent;
        })();
    }
]);