﻿invoiceModule.directive('amountCheckManualInput', ['$log', '$document', '$uibModal',
function ($log, $document, $uibModal) {
    'use strict';

    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/amount-check-manual-input/amount-check-manual-input.html' + '?_=' + Math.random(),
        scope:
        {
            isOpen: '=',
            reasonDataSource: '=',
            model: '=',
            parentElement: "@",
            refreshParent:"&"
        },
        link: function (scope, element) {
            $log.debug('amountCheckManualInput.ctor()...');

            scope.$watch('isOpen', function (newVal, oldVal) {
                if (newVal) {
                    scope.eventService.open();
                }
            });

            var parentElement = scope.parentElement
                ? $document[0].querySelector(scope.parentElement) : element[0];

            scope.eventService = {
                open: function () {
                    var modalInstance = $uibModal.open({
                        ariaLabelledBy: 'modal-title',
                        ariaDescribedBy: 'modal-body',
                        backdrop: 'static',
                        templateUrl: 'amount-check-manual-input-template.html',
                        controller: 'amountCheckManualInputController',
                        windowClass: 'amount-check-manual-input-popup center-popup',
                        appendTo: angular.element(parentElement),
                        scope: scope
                    });
                }
            };
        }
    };
}]);